set top [toplevel .rltoolbox]
wm title $top "RLtoolbox"
#set Main_width 700
set Main_width 650
set Main_height 540
#set Main_height 600
wm geometry $top ${Main_width}x$Main_height+0+0
wm resizable $top 0 0
set results [frame $top.f -width 700 -height 400 -bg darkblue]
label $results.fond -image [image create photo -file "${path_tcl}/RLtoolbox.gif"] -bg darkblue

menubutton $top.dp -text "Dynamic Programming   " -menu $top.dp.menu
menubutton $top.mc -text  "Monte Carlo    " -menu $top.mc.menu
menubutton $top.td -text "Temporal Difference" -menu $top.td.menu
menubutton $top.ge -text "Evaluative Feedback" -menu $top.ge.menu
menubutton $top.help -text "Help" -menu $top.help.menu

pack $results -side bottom -expand 1 -fill both
pack $results.fond -side top -anchor center -fill both -expand 1

pack $top.dp $top.mc $top.td $top.ge -side left
pack $top.help -side right


#Dynamic Programming Menu
menu $top.dp.menu
$top.dp.menu add command -label "Load Macros" -command {ScilabEval "exec(path+'/methods/dp/functions/load_dp.sce')"}
$top.dp.menu add cascade -label "Examples" -menu  $top.dp.menu.submenu

# DP Sub Menu
#to have acces to the variable and avoid some problem of speed interpretation
ScilabEval "exec(path+'/methods/dp/examples/demo_robot/environnement.txt');"
menu $top.dp.menu.submenu
$top.dp.menu.submenu add cascade -label "Grid 1" -menu $top.dp.menu.submenu.sub1
$top.dp.menu.submenu add cascade -label "Grid 2"  -menu $top.dp.menu.submenu.sub2

#Robot
source "${path_tcl}/methods/dp/examples/demo_robot/demo_robot.tcl"
$top.dp.menu.submenu add command -label "Robot" -command {help robot_h 
demo_robot}

#Gambler
$top.dp.menu.submenu add command -label "Gambler" -command {help gambler_h 
ScilabEval "exec(path+'/methods/dp/examples/demo_gambler/demo_gambler.sce')"}

#Grid1 submenu
menu $top.dp.menu.submenu.sub1
$top.dp.menu.submenu.sub1 add command -label "Policy Evaluation" -command {help grid1_h
ScilabEval "exec(path+'/methods/dp/examples/demo_grid1/demo_grid_Eval_Policy.sce')"}
$top.dp.menu.submenu.sub1 add command -label "Policy Improvement" -command {help grid1_h
ScilabEval "exec(path+'/methods/dp/examples/demo_grid1/demo_grid_Iter_Improv.sce')"}
$top.dp.menu.submenu.sub1 add command -label "Value Iteration" -command {help grid1_h
ScilabEval "exec(path+'/methods/dp/examples/demo_grid1/demo_grid_Iter_Eval.sce')"}

#Grid2 submenu
menu $top.dp.menu.submenu.sub2
$top.dp.menu.submenu.sub2 add command -label "Policy Evaluation" -command {help grid2_h
ScilabEval "exec(path+'/methods/dp/examples/demo_grid2/demo_grid2_Eval_Policy.sce')"}
$top.dp.menu.submenu.sub2 add command -label "Policy Improvement" -command {help grid2_h
ScilabEval "exec(path+'/methods/dp/examples/demo_grid2/demo_grid2_Iter_Improv.sce')"}
$top.dp.menu.submenu.sub2 add command -label "Value Iteration" -command {help grid2_h
ScilabEval "exec(path+'/methods/dp/examples/demo_grid2/demo_grid2_Iter_Eval.sce')"}
$top.dp.menu.submenu.sub2 add command -label "Change Gamma" -command {ScilabEval "exec(path+'/methods/dp/examples/demo_grid2/demo_grid2_Gamma.sce')"}

# Monte Carlo Menu
menu $top.mc.menu
$top.mc.menu add command -label "Load Macros" -command {ScilabEval "exec(path+'/methods/montecarlo/functions/load_functions.sce')"}
$top.mc.menu add cascade -label "examples" -menu  $top.mc.menu.submenu

#MC sub menus
menu $top.mc.menu.submenu
$top.mc.menu.submenu add cascade -label "BlackJack" -menu $top.mc.menu.submenu.submenu21
$top.mc.menu.submenu add cascade -label "Simplified BlackJack" -menu $top.mc.menu.submenu.submenu22

#MC submenu1
menu $top.mc.menu.submenu.submenu21
$top.mc.menu.submenu.submenu21 add command -label "OnPolicy" -command {help blackjack_h
ScilabEval "_model=1;_algo=1;exec(path+'/methods/montecarlo/MCInterface.sce')"}
$top.mc.menu.submenu.submenu21 add command -label "OffPolicy" -command {help blackjack_h
ScilabEval "_model=1;_algo=2;exec(path+'/methods/montecarlo/MCInterface.sce')"}

#MC submenu2
menu $top.mc.menu.submenu.submenu22
$top.mc.menu.submenu.submenu22 add command -label "OnPolicy" -command {help blackjack_h
ScilabEval "_model=2;_algo=1;exec(path+'/methods/montecarlo/MCInterface.sce')"}
$top.mc.menu.submenu.submenu22 add command -label "OffPolicy" -command {help blackjack_h
ScilabEval "_model=2;_algo=2;exec(path+'/methods/montecarlo/MCInterface.sce')"}

#GE Menu
menu $top.ge.menu
$top.ge.menu add command -label "Load Macros" -command {ScilabEval "exec(path+'/methods/eval_fb/n_armed_bandit/functions/load_functions.sce');"}
$top.ge.menu add cascade -label "examples" -menu  $top.ge.menu.submenu

#GE submenu
menu $top.ge.menu.submenu
$top.ge.menu.submenu add cascade -label "n_armed_bandit" -menu  $top.ge.menu.submenu.ttt


# GE submenu for N armed bandit
menu $top.ge.menu.submenu.ttt
$top.ge.menu.submenu.ttt add command -label "Train" -command {help nbandit_train_h
ScilabEval "_model=3;_algo=2;exec(path+'/methods/eval_fb/n_armed_bandit/interface.sce');"}


# TD Menu
menu $top.td.menu
$top.td.menu add command -label "Load Macros" -command {ScilabEval "exec(path+'/methods/td/functions/TD_load_functions.sce');"}
$top.td.menu add cascade -label "examples" -menu  $top.td.menu.submenu

# TD submenu
menu $top.td.menu.submenu
$top.td.menu.submenu add command -label "Random Walk" -command {help randomwalk_h
ScilabEval "_model=1;_algo=1;exec(path+'/methods/td/TD_Interface.sce');"}
$top.td.menu.submenu add cascade -label "Windy Grid" -menu $top.td.menu.submenu.wg
$top.td.menu.submenu add cascade -label "Tic Tac Toe" -menu  $top.td.menu.submenu.ttt

# TD submenu for Windy Grid
menu $top.td.menu.submenu.wg
$top.td.menu.submenu.wg add command -label "TD Sarsa" -command {help windygrid_h
ScilabEval "_model=2;_algo=1;exec(path+'/methods/td/TD_Interface.sce');"}
$top.td.menu.submenu.wg add command -label "TD Q learning" -command {help windygrid_h
ScilabEval "_model=2;_algo=2;exec(path+'/methods/td/TD_Interface.sce');"}
$top.td.menu.submenu.wg add command -label "TD R learning" -command {help windygrid_h
ScilabEval "_model=2;_algo=3;exec(path+'/methods/td/TD_Interface.sce');"}
$top.td.menu.submenu.wg add separator
$top.td.menu.submenu.wg add command -label "Edit Models" -command {help grid_edit
ScilabEval "_model=2;_algo=1;exec(path+'/methods/td/examples/windygrid/MDL_edit.sce');"}

# TD submenu for Tic Tac Toe
menu $top.td.menu.submenu.ttt
$top.td.menu.submenu.ttt add command -label "Play" -command {help ttt_play_h
ScilabEval "_model=3;_algo=1;exec(path+'/methods/td/TD_Interface.sce');"}
$top.td.menu.submenu.ttt add command -label "Train" -command {help ttt_train_h
ScilabEval "_model=3;_algo=2;exec(path+'/methods/td/TD_Interface.sce');"}
$top.td.menu.submenu.ttt add command -label "Benchmark" -command {help ttt_benchmark_h
ScilabEval "_model=3;_algo=3;exec(path+'/methods/td/TD_Interface.sce');"}

source "$path_tcl/methods/help.tcl"

# Help Menu
menu $top.help.menu
$top.help.menu add cascade -label "Dynamic Programming" -menu $top.help.menu.help_dp
$top.help.menu add cascade -label "Monte Carlo" -menu $top.help.menu.help_mc
$top.help.menu add cascade -label "Time Differential" -menu $top.help.menu.help_td
$top.help.menu add separator
$top.help.menu add command -label "About" -command "help about"

menu $top.help.menu.help_dp
$top.help.menu.help_dp add command -label "Grid1" -command "help grid1_h"
$top.help.menu.help_dp add command -label "Grid2" -command "help grid2_h"
$top.help.menu.help_dp add command -label "Gambler" -command "help gambler_h"
$top.help.menu.help_dp add command -label "Robot" -command "help robot_h"

menu $top.help.menu.help_mc
$top.help.menu.help_mc add command -label "Blackjack" -command "help blackjack_h"
$top.help.menu.help_mc add command -label "Simplified Blackjack" -command "help blackjack_h"

menu $top.help.menu.help_td
$top.help.menu.help_td add command -label "Random Walk" -command "help randomwalk_h"
$top.help.menu.help_td add command -label "Windy Grid" -command "help windygrid_h"
$top.help.menu.help_td add separator
$top.help.menu.help_td add command -label "Tic Tac Toe Play" -command "help ttt_play_h"
$top.help.menu.help_td add command -label "Tic Tac Toe Train" -command "help ttt_train_h"
$top.help.menu.help_td add command -label "Tic Tac Toe Benchmark" -command "help ttt_benchmark_h"
$top.help.menu.help_td add separator
$top.help.menu.help_td add command -label "Windy Grid Editor" -command "help grid_edit"

proc help {procedure} {
	global Main_width Main_height
	if [winfo exists .help]==1 {
		destroy .help
	}

	set help [toplevel .help -bg darkblue]
	wm geometry $help +[expr $Main_width+10]+0
	button $help.ok -text "OK" -command "destroy $help" -bg darkred -fg darkblue
	pack $help.ok -side bottom

	set f [frame $help.content -bg darkblue]
	pack $f -side top -fill both

	$procedure $f
}

wm protocol .rltoolbox WM_DELETE_WINDOW {
	if [winfo exists .help]==1 {
		destroy .help
	}
	if [winfo exists .pliz_wait]==1 {
		destroy .pliz_wait
	}
	destroy .rltoolbox
}
