proc demo_robot {} {

#ScilabEval "exec(path+'/methods/dp/examples/demo_robot/environnement.txt');"

set children [winfo children .rltoolbox.f]
foreach i $children {destroy $i}


set frame [frame .rltoolbox.f.f1 -bg darkblue]
label $frame.lgamma -text "gamma :" -bg darkblue -fg lightgrey
scale $frame.gamma  -orient horizontal -from 0 -to 1 -resolution 0.1 -bg darkblue -fg lightgrey
ScilabEval "TK_EvalStr('$frame.gamma set '+string(Gamma));"
pack $frame.lgamma $frame.gamma -side left
pack $frame -side top -pady 4

set frame [frame .rltoolbox.f.f2 -bg darkblue]
#alpha is the probability to stay in high state when the robot searches
#1-alpha is the probability to go into low state when the robot searches
label $frame.lalpha -text "alpha (in %): " -bg darkblue -fg lightgrey
scale $frame.alpha  -orient horizontal -from 0 -to 100 -bg darkblue -fg lightgrey
ScilabEval "TK_EvalStr('$frame.alpha set '+string(alpha*100));"
pack $frame.lalpha $frame.alpha -side left -in $frame
pack $frame -side top -pady 4


set frame [frame .rltoolbox.f.f3 -bg darkblue]
#beta  is the probability to stay in low state when the robot searches
#1-beta is the probability to be depleted
label $frame.lbeta -text "beta (in %):" -bg darkblue -fg lightgrey
scale $frame.beta  -orient horizontal -from 0 -to 100 -bg darkblue -fg lightgrey
ScilabEval "TK_EvalStr('$frame.beta set '+string(beta*100));"
pack $frame.lbeta $frame.beta -side left
pack $frame -side top -pady 4

set frame [frame .rltoolbox.f.f4 -bg darkblue]
#Rsearch : expected reward for searching
label $frame.lRS -text "Rsearch :" -bg darkblue -fg lightgrey
entry $frame.rs -width 8 -bg lightgrey -fg darkblue
ScilabEval "TK_EvalStr('$frame.rs insert end '+string(Rsearch));"
pack $frame.lRS $frame.rs -side left
pack $frame -side top -pady 4

set frame [frame .rltoolbox.f.f5 -bg darkblue]
#Rwait : expected reward for waiting
label $frame.lRW -text "Rwait :" -bg darkblue -fg lightgrey
entry $frame.rw -width 8 -bg lightgrey -fg darkblue
ScilabEval "TK_EvalStr('$frame.rw insert end '+string(Rwait));"
pack $frame.lRW $frame.rw -side left
pack $frame -side top -pady 4

set frame [frame .rltoolbox.f.f6 -bg darkblue]
#Rdepleted : penalty for being depleted
label $frame.lRD -text "Rdepleted :" -bg darkblue -fg lightgrey
entry $frame.rd -width 8 -bg lightgrey -fg darkblue
ScilabEval "TK_EvalStr('$frame.rd insert end '+string(Rdepleted));"
pack $frame.lRD $frame.rd -side left
pack $frame -side top -pady 4

set frame ".rltoolbox.f"
set lowstate "?"
set highstate "?"
text $frame.sentences -width 45 -height 3 -bg darkblue -fg lightgrey
$frame.sentences insert end "When robot's batteries are FULL it $highstate.\nOtherwise it $lowstate."
$frame.sentences configure -state disable
pack $frame.sentences -side top -pady 4

button $frame.compute -text "Compute" -bg darkred -fg darkblue -command {ScilabEval "exec(path+'/methods/dp/examples/demo_robot/compute.sce');"}
pack $frame.compute -side top -pady 4
label $frame.indications -text "gamma: discount rate\nalpha: probability to stay in high state when the robot searches\n1-alpha: probability to go into low state when the robot searches\nbeta: probability to stay in low state when the robot searches\n1-beta: probability to be depleted\nRsearch: expected reward for searching\nRwait : expected reward for waiting\nRdepleted : penalty for being depleted" -bg darkblue -fg yellow -justify left
pack $frame.indications -side top -pady 4
}
