//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Dynamic Programming             *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
function [V,T_V]=Iter_Policy_Evaluation(NbStates, NbActions, TransProb, Rewards, Gamma, Policy)

  //TestParam=verif_param_PIAV(NbStates,NbActions,TransProb,Rewards,Gamma,Prob)
  TestParam=%T;
  if TestParam==%F then, V="Check parametters types and dimensions", else,
    T_V=list();
    V=zeros(NbStates,1)
    Delta=15                  // Delta has this value to be greater than 0.001 so that the first iteration is possible
    cptr=0;
    while Delta>=0.1 & cptr<1000,
      cptr=cptr+1;
      T_V(cptr)=V;
      V_old=V;
      Delta=0
      for s=1:NbStates,
        v=V_old(s,1)                   // backup of the old value (for further comparison)
        S=0
        for a=1:NbActions,
          //S1=Prob(a,s)*sum((TransProb(a)(s,:).*(Rewards(a)(s,:)+Gamma*(V_old(:,1))')),'c')
	  S1=Prob(a,s)*(TransProb(a)(s,:)*( (Rewards(a)(s,:))'+Gamma*(V_old(:,1)) ))
          S=S+S1,
        end
	//only 1 decimal is relevant
        V(s,1)=round(S*10)/10;
	if abs(v-V(s, 1))>Delta then,
		Delta=abs(v-V(s, 1)),
	end,
      end
    end,
    if cptr==1000,
       V=cptr;
    end
  end
endfunction
