//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Dynamic Programming             *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
function [Pi,V,T_V,T_Pi]=Iter_Policy_Improv(NbStates,NbActions,TransProb,Rewards,Gamma,Actions_States)

   MAX_LOOP=1000;
  //TestParam=verif_param2(NbStates,NbActions,TransProb,Rewards,Gamma)
//  TestParam=%T;

//  if TestParam==%F then, Pi="Check parametters types and dimensions", else,
    T_V=list();
    T_Pi=list();
    V=zeros(NbStates,1);
    Pi=zeros(NbStates,4);
    Pi(:,1)=ones(NbStates,1);
    t_cptr=1;
    T_V(t_cptr)=V;
    T_Pi(t_cptr)=Pi;

policy_stable=%F;
while (policy_stable==%F),
    t_cptr=t_cptr+1;
    //POLICY EVALUATION
    cptr=0;                      //cptr verify infinite loop
    Delta=15;                    // Delta has this value to be greater than 0.1 so that the first iteration is possible
    while (Delta >= 0.1) & (cptr<MAX_LOOP),
      Delta=0;
      cptr=cptr+1;
      V_old=V;
      for s=1:NbStates,
        v=V_old(s,1)                                // backup of the old value (for further comparison)
        //S=sum((TransProb(Pi(s,1))(s,:).*(Rewards(Pi(s,1))(s,:)+Gamma*(V_old(:,1))')),'c')
	S=TransProb(argPi(Pi(s,:)))(s,:)*(Rewards(argPi(Pi(s,:)))(s,:)'+Gamma*(V_old(:,1)));
	V(s,1)=round(S*10)/10;
	if abs(v-V(s, 1))>Delta then,
              Delta=abs(v-V(s, 1));,
        end,
      end
    end
    T_V(t_cptr)=V;
    //END EVALUATION



    policy_stable=%T

    //POLICY IMPROVING

    for s=1:NbStates,
      b=Pi(s,:);
      //Max=sum((TransProb(1)(s,:).*(Rewards(1)(s,:)+Gamma*(V(:,1))')),'c');
      Max=-%inf;
      for a=1:NbActions,
            //S=sum((TransProb(a)(s,:).*(Rewards(a)(s,:)+Gamma*(V(:,1))')),'c')
	    S=(TransProb(a)(s,:)*(Rewards(a)(s,:)'+Gamma*(V(:,1))));
            if Actions_States(s,a)==1 then,
	       if  S>Max then,
		   Pi(s,:)=zeros(1,NbActions);
                   Pi(s,a)=1;
                   Max=S;,
	       end,
	       if  S==Max then,
                   Pi(s,a)=1;
	       end,
            end,
      end
      if or(b~=Pi(s,:)) then,
        policy_stable=%F;,
      end,
    end
    T_Pi(t_cptr)=Pi;
    //END IMPROVING

end,

endfunction


