//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Dynamic Programming             *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
//******* Macros - Iterative policy improving action value ********//

function [Pi,Q] = Iter_Policy_Improv_Action_Value(NbStates,NbActions,TransProb,Rewards,Gamma,Actions_States)

   MAX_LOOP=1000;
//  TestParam=verif_param_PIAV(NbStates,NbActions,TransProb,Rewards,Gamma,Prob)
//  if TestParam==%F then, Pi="Check parametters types and dimensions", else,

    Q=rand(NbActions,NbStates)
    Pi=zeros(NbStates,NbActions);
    Pi(:,1)=ones(NbStates,1);

    policy_stable=%F
    while (policy_stable==%F),

      // Policy Evaluation
      Delta=15           // Delta has this value to be greater than   0.001
      cptr=0                      //cptr verify infinite loop
      disp("--> Policy evaluation, be patient please");
      while Delta >= 0.001 & (cptr<MAX_LOOP),
        Delta=0
	Q_old=Q
	cptr=cptr+1;
        for a=1:NbActions,
          for s=1:NbStates,
            q=Q_old(a,s)                // backup of the old value (for further comparison)
            S=0
           for sprime=1:NbStates,
            S=S+TransProb(a)(s,sprime)*(Rewards(a)(s,sprime)+Gamma*Q_old(argPi(Pi(sprime,:)),sprime)),
           end
            Q(a,s)=S
            if abs(q-Q(a,s))>Delta then,
	    	Delta=abs(q-Q(a,s));,
	    end,
          end
        end
       end

      // Policy Improvement
      policy_stable=%T

      for s=1:NbStates,
        b=Pi(s,:)
        Max=-%inf
        for a=1:NbActions
	   if Actions_States(s,a)==[1] then,
	     if Q(a,s) > Max then,
	        Pi(s,:)=zeros(1,NbActions);
          	Pi(s,a)=1;
          	Max=Q(a,s);,
	     end,
	     if Q(a,s) == Max then,
	       Pi(s,a)=1;
	     end,
	  end,
        end
        if or(b~=Pi(s,:)) then, policy_stable=%F;, end,
      end
    end
endfunction
