//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Dynamic Programming             *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
function [Pi,V,T_V] = Value_Iteration (NbStates,NbActions,TransProb,Rewards,Gamma,Actions_States)

//TestParam=verif_param2(NbStates,NbActions,TransProb,Rewards,Gamma)
TestParam=%T

if TestParam==%F then, pi="Check parametters types and dimensions",
else,

  teta=0.0000000001;
  T_V=list();
  V=zeros(NbStates,1);
  V(NbStates,1)=1;
  Pi=zeros(NbStates,NbActions);
  Pi(:,1)=ones(NbStates,1);
  t_cptr=0;

  delta=15;

  while delta>teta,

    delta=0;
    t_cptr=t_cptr+1;
    T_V(t_cptr)=V;
    for s=1:NbStates,
      v=V(s,1);
      som_max=-%inf
      for a=1:NbActions,
	if Actions_States(s,a) == 1 then,
	  som=TransProb(a)(s,:)*(Rewards(a)(s,:)'+Gamma*V(:,1));
	  if som>som_max then,
	    V(s,1)=som;
	    som_max=som;
	  end
	end
      end
      if delta<abs(v-V(s,1)) then,
	delta=abs(v-V(s,1)),
      end
    end
  end


  for s=1:NbStates,
    Max = -%inf;
    stop = s;
    for a=1:NbActions,
      if Actions_States(s,a) == 1 then,
	som=TransProb(a)(s,:)*(Rewards(a)(s,:)'+Gamma*V(:,1));
	if som>Max then,
	  Max = som;
	  Pi(s,:)=zeros(1, NbActions);
	  Pi(s,a)=1;
	end
	if som==Max then,
	  Pi(s,a)=1;
	end
      end
    end
  end

end

endfunction

