//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Dynamic Programming             *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
function ParamOk=verif_param2(NbStates,NbActions,TransProb,Rewards,Gamma,Actions_States)

  //ParamOk = and([type(NbStates)==1,type(NbActions)==1,type(Gamma)==1,type(TransProb)==15,type(Rewards)==1])

  ParamOk=%t;
  
  //Types verification : 1 for constant matrix 15 for list
  
  if type(NbStates)~=1 then
    printf("ERROR: NbStates incorrect data type.\n Type found: %s , should be : constant \n",typeof(NbStates),);
    ParamOk=%f;
  end,

  if type(NbActions)~=1 then
    printf("ERROR: NbActions incorrect data type.\n Type found: %s , should be : constant \n",typeof(NbActions)); 
    ParamOk=%f;
  end,  
  
   if type(Gamma)~=1 then
     printf("ERROR: Gamma incorrect data type.\n Type found: %s , should be : constant \n",typeof(Gamma)); 
    ParamOk=%f;
  end, 
  if type(TransProb)~=15 then
    printf("ERROR: TransProb incorrect data type.\n Type found: %s , should be : list \n",typeof(TransProb)); 
    ParamOk=%f;
  end,  
  
  if type(Rewards)~=15 then
    printf("ERROR: Rewards incorrect data type.\n Type found: %s , should be : list \n",typeof(Rewards)); 
    ParamOk=%f;
  end,  
  
  if type(Actions_States)~=1 then
    printf("ERROR: Actions_States incorrect data type.\n Type found: %s , should be : constant \n",typeof(Actions_States),);
    ParamOk=%f;
  end,
  //end of type verification
  
  
  // 0 < gamma <=1 ????
  if and([Gamma<=1,Gamma>0]) == %f then
     printf("ERROR: Gamma should be : 0< gamma <=1 \n");    
     ParamOk=%F;
   end
   
   
  //size of lists
  if size(TransProb)~=NbActions then
    printf("ERROR: incorrect size for TransProb\n");
    paramOk = %F;
  end
  
  if size(Rewards)~=NbActions then
    printf("ERROR: incorrect size for rewards\n");
    paramOk = %F;
  end  
  
  if size(Actions_States)~=[NbStates,NbActions] then
    printf("ERROR: incorrect size of parameters for Actions States\n");
    ParamOk = %F;
  end 
      
  //size of each matrix for every actions    
  if ParamOk==%T then,
    for a=1:NbActions,
      if size(TransProb(a))~=[NbStates,NbStates] then
	printf("ERROR: incorrect size of parameters for TransProb (action %d) \n",a);
	ParamOk = %F;
      end
      
      if size(Rewards(a))~=[NbStates,NbStates] then
	printf("ERROR: incorrect size of parameters for Rewards (action %d) \n",a);
	ParamOk = %F;
      end
    end
  end
endfunction
