proc grid1_h {window} {

set aide "Grid World example 1

The problem here is quite simple : the agent have to learn that he has to go out from the grid by 2 special cells, the left-top corner and the right-bottom corner. This is an episodic task since when the agent has reach one of the two exits, it can not move anymore.\n"
set aide "$aide - With Policy Evaluation, we can see the value of a given policy.  It's possible to specify a policy by giving the probability to choose one of the four actions (left, rigth, up or down) in each state. This is done by filling a complete grid which is initialized with 0.25 everywhere, i.e. the equiprobable policy."
set aide "$aide The result found is also plotted in a 3d graph in order to be more visual. Finally it's possible to see how the algorithm find the result since it's possible to use the slide bar at the bottom to see the result after each iteration of the algorithm.\n" 
set aide "$aide - With Policy Improvement (be patient please, it takes more time), there is more information shown : the policy. In fact, the grid is drawn and in each cell we see the optimal action(s) that can be choosen in order to achieve our goal. Like previously, we can find the results after each iteration."
set aide "$aide With Value Iteration, which is the fastest algorithm, we have the same results as with Policy Improvement, but it's not possible to see how the policy changes at each step since it is computed at the end when we know the optimal value function.
Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See pages 92-94."
text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
$window.t insert 0.0 $aide
scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
$window.t configure -state disable
pack $window.t $window.scroll -side left -fill y
}


proc grid2_h {window} {

set aide "Grid World number 2

This second grid problem is a little bit more complex. The agent must learn that some cells are more benfits than other. Yet, when the agent is on cell A, whatever action he chooses, it goes to celle A' and get a reward of 10. Similarly, when it is on B, it goes to B' and get a reward of 5. If the agent tries to go out, then a reward of -1 is received, and on all the other case a reward of 0 is given.\n"

#Remember to put a figure of the game with A A' B and B'

set aide "$aide These conditions implies that we are now with a continuous problem. So we have to maximize the reward for a certain amount of time that can be changed with the parameter Gamma. For example, Gamma=0 means that we will maximize the immedaite reward an d Gamma=1 means that we  will maximize the total reawrds from the beginning.\n"

set aide "$aide For each of the algorithm available here, Policy Evaluation, Policy Improvement and Value Iteration, the use is exactly the same as with the grid 1 exemple. So, refer to the help of this exemple for details, please.
Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See pages 92-94."
text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
$window.t insert 0.0 $aide
scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
$window.t configure -state disable
pack $window.t $window.scroll -side left -fill y
}


proc robot_h {window} {

    set aide "RECYCLING ROBOT

This problem modelize a recycling robot designed to search for cans in a room.\n The robot has three possible actions:\n (1) search for cans\n (2) wait for somenone to bring it a can\n (3) go to home base and recharge.\n\n The robot has two possibles states:\n (1) high battery\n (2) low battery.\n\n"
    set aide "$aide There are several parameters which can be tweaked in order to modify robot behavior : gamma, alpha, beta, Rsearch, Rwait and Rdepleted. Description of these variables are in the graphic inter~ace. After setting the parameters, clicking on the COMPUTE button launch computation of Value_Iteration algorithm.\n"

    set aide "$aide The results of the algorithm is written in a text box explaining the robot optimal behavior.

Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See pages 6-7, 55, 56, 66-68, 78, 83"
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}


proc gambler_h {window} {

    set aide "GAMBLER

This Demo is not complete. It will be completed in version 2 of RLtoolbox

A gambler has the opportunity to make bets on the outcomes of a sequence of coin flips. If the coin comes up heads, then he wins as many euros as he has staked on that flip but if it is tails then he loses his stake. The game ends when the gambler wins by reaching his goal of 10 (i.e. NbStates-1=10) euros or loses by running out of money. On each flip, the gambler must decide what portion of his capital to stake. The state is the capital of the gambler. There are 11 states because the gambler can have between 0 and 10 euros and the actions are stakes.

Be patient please, It will take about 50 secondes!.

Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See pages 101-103"
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}

proc blackjack_h {window} {

    set aide "BLACKJACK example

This example is based on the famous card game. The object is to have the card sum to be greater than the dealer without exceeding 21. The problem model has 200 states corresponding to whatever we have a useable ace, our current card sum, and the dealer's showing card.
NB: For simple blackJack we only consider 10 states corresponding to the card sum the player can have (ignoring dealer showing card)"
    set aide "$aide Rewards are: +1 for winning, 0 for a draw and -1 for losing. Possibles actions are: stick (stop receiving cards), hit (receive another)"
    set aide "$aide When choosing BlackJack two possible algorithms are possible: On and Off Policy. For each algorithms possible actions are:
(1) Print Policy: display a formated representation of the matrix Policy Pi(s,a),    
(2) Print Policy Evaluation: display a formated representation of the matrix Policy Evaluation Q(s,a),         
(3) Set epsilon: allow to set the soft policy epsilon factor,           
(4) Benchmark Policy: utility used to measure the frequency at which the current policy reaches its goal. You will be asked to enter the number of episodes you want to simulate   
(5) On-Policy Learning: compute a defined number of episodes and use on-policy algorithm to improve the policy. You will be asked to enter the number of episodes you want to simulate 
(6) Off-Policy Learning: compute a defined number of episodes and use on-policy algorithm to improve the policy. You will be asked to enter the number of episodes you want to simulate        
(7) Load Policies: load policies from the model environnement file.
(8) Save Policies: save policies to the model environnement file.
Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See pages 112-114, 121, 131."
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}




proc randomwalk_h {window} {

    set aide "RANDOM WALK problem

This problem is designed to compare tha prediction abilities of TD(0) algorithm and constant-alpha MonteCarlo. This example is a simple Markov process containing 5 states (A,B,C,D,E). The initial state is C, and terminal states are on the left of A and on the right of E.\n\n"

    set aide "$aide The rewards are all 0 expect for right action in state E which has a reward of +1. The policy to be evaluated is a complete random policy.\n\n"

    set aide "$aide After computing this example the value of each state is displayed. More over a set of 4 graphs are displayed (please zoom out the ScilabGraphic window): Evolution of the estimated value during iterations, Error between theorical and estimate and finally comparison between TD(0) and constant alpha MonteCarlo.
Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See page 139."
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview"
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}


proc windygrid_h {window} {

    set aide "WINDY GRID

This example is designed to test three different algorithms of Time Differential : TD Sarsa, TD Q-learning and TD R-learning.

The problem is a grid world containing a start state, one or several states and (optionnaly) some wind and some obstacles. The objective is to find a path from start to goal while maximizing rewards.

When lauching the example you have to choose either an existing modle or edit a new model before computing.

Reference: Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998. See pages 146-148.
"
text $window.t -width 55  -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
$window.t insert 0.0 $aide
scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
$window.t configure -state disable
pack $window.t $window.scroll -side left -fill y

}

proc grid_edit {window} {

set aide "The grid editor let you create or modify easily a model by a graphical inter~ace. To create a new model you just have to load Mdl_LoadNew.mdl. It is so possible to modify the rewards of the different elements of the world (such as walls and holes) and the algorithm's variables (alpha, beta, epsilon). It is also possible to place the obstacles and the start and finish points graphically, using the mouse.

The start point is modelised by a grey disk, the finish point(s) by yellow disk, the walls by darkred square with lightgrey strips, the cliffs by black squares and the holes by black square with a lightgrey disk. To put an element you have to selection it and click on an empty case, to remove it you just have to click again on it.

For the wind, you must enter the force of it in the text aeras. The sign of the value entered determine the direction of the wind."
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}

proc ttt_play_h {window} {

    set aide "To play you first have to choose the lookuptable the computer player will use. Then you had to the kind of the different players (human or computer). Finally, by clicking new game you can play. Between two new games you can change the kind of the players.

References: 

- Sebastian Siegel. Training an artificial neural network to play tic tac toe, ECE 539 Term Project.- http://www.cae.wisc.edu/~ece539/project/f01/
- Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998."    
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}

proc ttt_train_h {window} {

    set aide "A lookup table is a table relating the visited winning (greedy) states or the new (explorated) states  and their corresponding values V(s) (the probabilities to win starting from these states) during each game. Two tables are saved together for two players (the player and the adversory player) in the same file caled (*.dat). The training formula is: 
    	V(s)=V(s)+alpha * (V(s')-V(s)),     	
where s'and s are the current and the preceeding state respectively.
To train the agent (updating his lookup table) you first have to set the different parameters:
- The reward (r) when a game end in a draw game (0 or 1)
- The learn parameter (alpha): the step size for the bootstrap (e.g. 0.2)
- The random parameter (epsilon): we choos somme games defined 
  by this parameter to explore other states, (e.g. 0.1)
- The number of game to simulate (e.g. 1000)
Then you have to choose the destination file and finally you just have to wait the end of the learning. 
At the end you will see graphics representing the percentage of won and draw games plus the number of states visited by each player (positive or negative).
References: 
- Sebastian Siegel. Training an artificial neural network to play tic tac toe, ECE 539 Term Project.- http://www.cae.wisc.edu/~ece539/project/f01/
- Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998."    
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}

proc ttt_benchmark_h {window} {

    set aide "A  lookup table is a table relating the visited wining (greedy) states or the new (explorated) states  and their corresponding values V(s) (the probabilities to win starting from these states) during each game. Two tables are saved together for two players (the player and the adversory player) in the same file caled (*.dat). You have to choose the lookup table that will be used by the first player then the one that will be used by the second player. At the end you will see graphics representing the percentage of won and draw games
    
References: 

-  Sebastian Siegel. Training an artificial neural network to play tic tac toe, ECE 539 Term Project.- http://www.cae.wisc.edu/~ece539/project/f01/
- Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning). Ed. MIT Press, Cambidge, MA, 1998."
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}

proc about {window} {

 set aide "REINFORCEMENT LEARNING TOOLBOX


This toolbox solves reinforcement learning problems using 3 different classes of methods:
    - Dynamic programming
    - Monte Carlo methods
    - Temporal-difference learning


The used algorithms are taken from
Reinforcement Learning: An Introduction,
by Richard S. Sutton and Andrew G. Barto
http://www-anw.cs.umass.edu/~rich/book/the-book.html\n"
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y

}


proc nbandit_train_h {window} {
 
set aide "This demo is used to roughly assess the relative effectiveness of the greedy and eps-greedy methodes, the may be compared numerically on a suite of test problems.For the 'simple' case, this is a set of a number of Tasks (=2000) randomly generated n-armed bandit tasks with a default value n =10.For each action a, the rewards were selected from a normal (Gaussian) probability distribution  with mean Q*(a) and variance 1. The 2000 n-armed bandit tasks were generated by reselecting the Q*(a) 2000 times each a normal distribution with mean 0 and variance 1. Averaging over tasks, we can get a plot of per~ormance and behavior of various methods as they improve with experience over k (=1000). plays.The robot can chose between n-arms. Each arms can give a different reward that is calculated randomly. A priori, the player doesn't know anything about the reward it can obtain by choosing an arm, so it has to learn it buy reinforcement learning.  
     	
The reinforcement comparison idea is used in updating the action preferences. After each play, the preference for the action  selected on that play, a_t, is incremented by the difference between reward rt and the reference reward rt~.:  
    	
    	p_t+1=p_t(a_t)+beta * (rt-rt~)
    	
where p_t(a_t) is the preference for action a on play t.These preferences might be used to determine action-selection probabilities (voir reference page 42). beta is a positive step-size parameter.

After the update, the reference reward is updated :

rt~+1=rt~+alpha * (rt-rt~)

where  0<alpha<=1, is a step-size parameter.
    	
To train the agent (updating his lookup table) you first have to set the different parameters:

- The learn parameter (alpha): the coefficient which determine the influence of the last reward, used for simple and comparison methods only. The greater the parameter is, the more influent are the last events. (e.g. 0.2)
- The learn parameter (beta): the coefficient for the pursuit method. A great value gives quicker but bolder result. (e.g. 0.2)
- The learning method: the function which choose how the rewards affect the next choice
'simple': eps-greedy method using the formula rt~+1=r~_+alpha * (rt-rt~) to calculate the new coefficient affected to each choice. All the 1/eps turn, it choose randomly a lever.
'comparison': same method that simple but the 1/eps turn choice is oriented according to the previous results so as to accelerate the learning.
'pursuit': this name set a purpose at the beginning of the learning and try to complete it the more quickly. Each choice has a probability to be played, and each time a choice appears to be the best one, the probability that it will be played next time is increased. The learn parameter beta affect how quickly the probabilities rise.
- eps: random parameter (epsilon): we choos some games defined 
  by this parameter to explore other states, (e.g. 0.3)
- k: number of plays to simulate (e.g. 1000)
- n: number of arms for the bandit (e.g. 10)
- change: parameter (change: change the rewards): for the non-stationary problem (e.g. 0.3) 
- The number of tasks for the bandit (e.g. 2000)

For more details, please look at the reference.

Caution:the number of tasks to run the simulation is fixed to 2000.

References: 
- Richard S. Sutton, Andrew G. Barto. Reinforcement Learning (Adaptive Computation and Machine Learning), Chapter 2. Ed. MIT Press, Cambidge, MA, 1998."    
    text $window.t -width 55 -height 25 -wrap word -yscrollcommand "$window.scroll set" -bg darkblue -fg lightgrey
    $window.t insert 0.0 $aide
    scrollbar $window.scroll -orient vertical -command "$window.t yview" -bg darkred
    $window.t configure -state disable
    pack $window.t $window.scroll -side left -fill y
}
