//*****************************************************//
//*   Reinforcement Learning Toolbox                  *//
//*   Interface for RLtoolbox_V.1 (Monte Carlo method)*//
//*   T. AL ANI                                       *//
//*   ESIEE-ASI Paris - March 2004                   *//
//*****************************************************//

//*********************************//
Mdl_Env_File = '';

//****************************************************************************//
// Declaration of the functionnal elements of the interface   		     //
// Common functions 
//*************************************************************************//
	DisplayPiFnct = 'Display Policy Pi(s,a) (in scilab window)';
	DisplayQFnct  = 'Display Policy Evaluation Q(s,a) (in scilab window)';
	BenchFnct     = 'Benchmark Policy';

	DisplayPiExec = 'printf(''\n     Policy :'');, if and([length(_a)==1;length(_s)==1]) then, Mc_Disp_Mat_S_A(Pi, ''Pi'');, else, disp(matrix(Pi,[_s,_a])), end';
	DisplayQExec  = 'printf(''\n    Policy Evaluation :'');, if and([length(_a)==1;length(_s)==1]) then, Mc_Disp_Mat_S_A(Q, ''Q'');, else disp(matrix(Q,[_s,_a])), end';
	
	if MSDOS then
		BenchExec     = 'exec(path+''\methods\montecarlo\functions\Mc_Benchmark_Policy.sce'');';
	else
		BenchExec     = 'exec(path+''/methods/montecarlo/functions/Mc_Benchmark_Policy.sce'');';
	end
	//*******************************************************************************//

	// On-policy functions
	//*******************************************************************************//
	epsilon='0.01';
	OnFunct1 = DisplayPiFnct;
	OnFunct2 = DisplayQFnct;
	OnFunct3 = 'Set Soft-Policy epsilon';
	OnFunct4 = BenchFnct;
	OnFunct5 = 'Start Learning';
	OnFunct6 = 'Save Current Policy';
	OnFunct7 = 'Load Saved Policy';

	OnFunctExec1 = 'Pi = Pi_on;,' + DisplayPiExec;
	OnFunctExec2 = 'Q  = Q_on;,'  + DisplayQExec;
	////OnFunctExec3 = 'printf(''\nSoft-Policy epsilon = %1.3f'', epsilon);,epsilon = input(''new epsilon '');, disp(epsilon);';
	OnFunctExec3 = 'epsilon=''0.01'';,epsilon=x_dialog(''Please introduce the new epsilon'',epsilon);,epsilon=evstr(epsilon);,disp(epsilon);';
	OnFunctExec4 = 'Pi = Pi_on;,' + BenchExec;
	if MSDOS then
		OnFunctExec5 = 'exec(path+''\methods\montecarlo\functions\On_Policy_Learning.sce'');';
	else
		OnFunctExec5 = 'exec(path+''/methods/montecarlo/functions/On_Policy_Learning.sce'');';
	end
	OnFunctExec6 = 'save(Mdl_Env_File + ''_Mdl_On.bin'',   Pi_on  ,   Pi_onb  ,   Q_on  ,   Returns  );, disp(''On-Environnement is Saved'');';
	OnFunctExec7 = 'load(Mdl_Env_File + ''_Mdl_On.bin'', ''Pi_on'', ''Pi_onb'', ''Q_on'', ''Returns'');, disp(''On-Environnement is Loaded'');';

	OnFunct     = [OnFunct1     OnFunct2     OnFunct3     OnFunct4     OnFunct5     OnFunct6     OnFunct7];
	OnFunctExec = [OnFunctExec1 OnFunctExec2 OnFunctExec3 OnFunctExec4 OnFunctExec5 OnFunctExec6 OnFunctExec7];
	//*******************************************************************************//

	// Off-Policy functions
	//*******************************************************************************//
	OffFunct1 = 'Display Policy Pi(s,a) (in scilab window)';
	OffFunct2 = 'Display Policy Evaluation Q(s,a) (in scilab window)';
	OffFunct3 = 'Benchmark Policy';
	OffFunct4 = 'Start Learning';
	OffFunct5 = 'Save Current Policy';
	OffFunct6 = 'Load Saved Policy';

	OffFunctExec1 = 'Pi = Pi_off;,' + DisplayPiExec;
	OffFunctExec2 = 'Q  = Q_off;,'  + DisplayQExec;
	OffFunctExec3 = 'Pi = Pi_off;,' + BenchExec;
	if MSDOS then
		OffFunctExec4 = 'exec(path+''\methods\montecarlo\functions\Off_Policy_Learning.sce'');';
	else
		OffFunctExec4 = 'exec(path+''/methods/montecarlo/functions/Off_Policy_Learning.sce'');';
	end
	OffFunctExec5 = 'save(Mdl_Env_File + ''_Mdl_Off.bin'',   Pi_off  ,   N  ,   D  ,   Q_off  );, disp(''Off-Environnement is Saved'');';
	OffFunctExec6 = 'load(Mdl_Env_File + ''_Mdl_Off.bin'', ''Pi_off'', ''N'', ''D'', ''Q_off'');, disp(''Off-Environnement is Loaded'');';

	OffFunct     = [OffFunct1     OffFunct2     OffFunct3     OffFunct4     OffFunct5     OffFunct6];
	OffFunctExec = [OffFunctExec1 OffFunctExec2 OffFunctExec3 OffFunctExec4 OffFunctExec5 OffFunctExec6];
	//*******************************************************************************///

	//  Disponible algorithms
	//*********************************//
	Algo1 = 'On Policy Algotihm';
	Algo2 = 'Off Policy Algorithm';

	AlgoTitle = [Algo1       Algo2];

	AlgoFunct = list();
	AlgoExec  = list();

	AlgoFunct(1) = OnFunct;
	AlgoExec(1)  = OnFunctExec;

	AlgoFunct(2) = OffFunct;
	AlgoExec(2)  = OffFunctExec;
	//*********************************//

	//**************************************************//
	//*  Insert here the names of your new models      //
	Items = ['blackjack' 'simplified_blackJack'];
	//***********************************************//

		// kill all the functions of classe MonteCarlo - eventually yet defined 
		clear Mdl_Init_State;, clear Mdl_Get_State;, clear Mdl_Stop;, clear Mdl_Reward;, clear Mdl_Verif_But;

		clear Mc_Action_Select;, clear Mc_Creat_Episode;, clear Mc_First_Occurrence;, clear Mc_Lin_State_Action;
		clear Mc_Linear;, clear Mc_Matrix_State;, clear Mc_Matrix_Action;, clear Mc_Disp_Mat_S_A;

		clear Mc_On_Policy_Evaluation;, clear Mc_On_Policy_Improve;
		clear Mc_Off_Policy_tau;, clear Mc_Off_Policy_Evaluation;, clear Mc_Off_Policy_Improve;

		// Chargement des fonctions et variables d'environnement
		if MSDOS then
			exec(path+'\methods\montecarlo\examples\' + Items(1,_model) + '\' + Items(1,_model) + '_Mdl_Load.sce');
			exec(path+'\methods\montecarlo\functions\MonteCarlo_Environnement.sce');
			getf(path+'\methods\montecarlo\examples\' + Items(1,_model) + '\' + Items(1,_model) + '_Mdl_Functions.sci');
			getf(path+'\methods\montecarlo\functions\Mc_Control_Functions.sci');
			getf(path+'\methods\montecarlo\functions\Mc_Off_Policy_Functions.sci');
			getf(path+'\methods\montecarlo\functions\Mc_On_Policy_Functions.sci');
			Mdl_Env_File = path+'\methods\montecarlo\examples\' + Items(1,_model) + '\' + Items(1,_model);
		else
			exec(path+'/methods/montecarlo/examples/' + Items(1,_model) + '/' + Items(1,_model) + '_Mdl_Load.sce');
			exec(path+'/methods/montecarlo/functions/MonteCarlo_Environnement.sce');
			getf(path+'/methods/montecarlo/examples/' + Items(1,_model) + '/' + Items(1,_model) + '_Mdl_Functions.sci');
			getf(path+'/methods/montecarlo/functions/Mc_Control_Functions.sci');
			getf(path+'/methods/montecarlo/functions/Mc_Off_Policy_Functions.sci');
			getf(path+'/methods/montecarlo/functions/Mc_On_Policy_Functions.sci');
			Mdl_Env_File = path+'/methods/montecarlo/examples/' + Items(1,_model) + '/' + Items(1,_model);
		end

		Title     = AlgoTitle(_algo);
		Items     = AlgoFunct(_algo);
		FunctExec = AlgoExec(_algo);
				//*	 Select a Function	*//
				_prg = 1;
				while _prg <> 0

					_prg = x_choose(Items,Title);
					if _prg <> 0 then execstr(FunctExec(_prg));, end

				end  // while _prg <> 0

//*********************************************************//




