//****************************************//
//*   Reinforcement Learning Toolbox     *//
//*   MonteCarlo-BlackJack demonstration *//
//*   T. AL ANI                          *//
//*   ESIEE-ASI Paris - March 2004      *//
//****************************************//

//************************************************//
//*               Mdl_Init_State                  *//
//************************************************//
function state=Mdl_Init_State()

  Score_Player = BJ_DrawCard()
  if Score_Player == 1 then Score_Player = 11, end
  card = BJ_DrawCard()
  if card == 1 then card = 11, end
  Score_Player = Score_Player + card
  if Score_Player == 22 then Score_Player = 12, end
  
  Score_Bank = BJ_DrawCard()
  if Score_Bank == 1 then Score_Bank = 11, end

  state = [Score_Player Score_Bank]

endfunction
//************************************************//

//************************************************//
//*              Mdl_Get_State                    *//
//************************************************//
function ns=Mdl_Get_State(Episode)

  turn = length(Episode)
  Score_Player = Episode(turn)(1)
  Score_Bank = Episode(turn)(2)
  
  // The player draw a card
  card = BJ_DrawCard()
  if and([card==1;Score_Player<=10]) then
    card = 11
  end
  
  Score_Player = Score_Player + card;
  
  // bust-out
  if Score_Player > 22 then Score_Player = 22, end

  ns = [Score_Player Score_Bank]
  
endfunction
//************************************************//

//************************************************//
//*              Mdl_Stop                       *//
//************************************************//
function Stop=Mdl_Stop(Episode)
  
  
  // Stopping condition: the player decide to stop
  // (that it voluntary or constrained and is forced:
  //  --> score > 21)
  if Episode(length(Episode))(3) == 1  then
    Stop = 1
  else
    Stop = 0
  end

endfunction
//************************************************//

//************************************************//
//*               Mdl_Reward                     *//
//************************************************//
function Reward=Mdl_Reward(Episode, turn)

  Reward = 0

  Score_Player  = Episode(turn)(1)
  Score_Bank  = Episode(turn)(2)
  action        = Episode(turn)(3)

  // deux actions sont possibles:
  // 1 :: S'arrter
  if action == 1 then
    if Score_Player > 21 then
      Reward = -1  // The player is loss
     
    else
      Score_Bank = BJ_DrawBank(Score_Bank, Score_Player)
    
      if Score_Player == Score_Bank then
        Reward = 0  // Draw
      else
        if or([Score_Player > Score_Bank ; Score_Bank > 21]) then
          Reward = 1  // The playe won
        else
          Reward = -1 // The player loss
        end
      end
    
    end
  
  // 2 :: Draw a card
  else
    Score_Player = Episode(turn+1)(1)
    if Score_Player > 21 then
      Reward = -1  // The player loss
    else
      Reward = 0
    end
  
  end
  
endfunction

//************************************************//

//************************************************//
//*               Mdl_Check_Goal                 *//
//************************************************//
function But=Mdl_Check_Goal(Episode)

  But = 0
  
  Score_Player  = Episode(length(Episode))(1)
  Score_Bank  = Episode(length(Episode))(2)
  
  if Score_Player <= 21 then
    Score_Bank = BJ_DrawBank(Score_Bank, Score_Player)
    if or([Score_Player > Score_Bank ; Score_Bank > 21]) then But = 1, end
  end

endfunction
//************************************************//

//************************************************//
//*              BJ_DrawCard                   *//
//************************************************//
function card=BJ_DrawCard()

  card=floor(rand()*13)+1
  if card > 10 then card=10,end

endfunction
//************************************************//

//************************************************//
//*              BJ_DrawBank                     *//
//************************************************//
function bs=BJ_DrawBank(bs, cs)

  while bs < 17
    card = BJ_DrawCard()
    if and([card==1;bs<=10]), card = 11, end
    bs = bs + card
  end

  // bust-out
  if bs > 22 then bs = 22, end

endfunction
//************************************************//

