//***************************************************//
//*   Reinforcement Learning Toolbox                *//
//*   MonteCarlo-Simplified BlackJack demonstration *//
//*   T. AL ANI                                     *//
//*   ESIEE-ASI Paris - March 2004                 *//
//***************************************************//

//************************************************//
//*               Mdl_Init_State                  *//
//************************************************//
function state=Mdl_Init_State()

  Score_Player = BJS_DrawCard()
  if Score_Player == 1 then Score_Player = 11, end
  carte = BJS_DrawCard()
  if carte == 1 then carte = 11, end
  Score_Player = Score_Player + carte
  if Score_Player == 22 then Score_Player = 12, end
  
  state = [Score_Player]

endfunction
//************************************************//

//************************************************//
//*              Mdl_Get_State                    *//
//************************************************//
function ns=Mdl_Get_State(Episode)

  turn = length(Episode)
  Score_Player = Episode(turn)(1)

  // The player draw a card
  carte = BJS_DrawCard()
  if and([carte==1;Score_Player<=10]) then
    carte = 11
  end
  
  Score_Player = Score_Player + carte;
  
  // bust-out
  if Score_Player > 22 then Score_Player = 22, end

  ns = [Score_Player]
  
endfunction
//************************************************//

//************************************************//
//*              Mdl_Stop                       *//
//************************************************//
function Stop=Mdl_Stop(Episode)
  // Stopping condition: the player decide to stop
  // (that it voluntary or constrained and is forced:
  //  --> score > 21)
  if Episode(length(Episode))(2) == 1  then
    Stop = 1
  else
    Stop = 0
  end

endfunction
//************************************************//

//************************************************//
//*               Mdl_Reward                     *//
//************************************************//
function Reward=Mdl_Reward(Episode, turn)

  Reward = 0

  Score_Player = Episode(turn)(1)
  action       = Episode(turn)(2)

  // deux actions sont possibles:
  // 1 :: S'arrter
  if action == 1 then
    if Score_Player > 21 then
      Reward = -1  // The player loss
      
    else
      Score_Bank = BJS_DrawBank()
    
      if Score_Player == Score_Bank then
        Reward = 0  // Draw
      else
        if or([Score_Player > Score_Bank ; Score_Bank > 21]) then
          Reward = 1  // The player won
        else
          Reward = -1 // The player loss
        end
      end
    
    end
  
  // 2 :: Tirer une Carte
  else
    if Episode(turn+1)(1) > 21 then
      Reward = -1  // The player loss
    else
      Reward = 0
    end
  
  end
  
endfunction
//************************************************//

//************************************************//
//*               Mdl_Check_Goal                 *//
//************************************************//
function But=Mdl_Check_Goal(Episode)

  But = 0

  Score_Player = Episode(length(Episode))(1)

  if Score_Player <= 21 then
    Score_Bank = BJS_DrawBank()
    if or([Score_Player > Score_Bank ; Score_Bank > 21]) then But = 1, end
  end

endfunction
//************************************************//




//************************************************//
//*              BJS_DrawCard                  *//
//************************************************//
function carte=BJS_DrawCard()

  carte=floor(rand()*13)+1
  if carte > 10 then carte=10,end

endfunction
//************************************************//

//************************************************//
//*               BJS_DrawBank                *//
//************************************************//
function bs=BJS_DrawBank()

  bs = 0

  while bs < 17
    carte = BJS_DrawCard()
    if and([carte==1;bs<=10]), carte = 11, end
    bs = bs + carte
  end

  // bust-out
  if bs > 22 then bs = 22, end

endfunction
//************************************************//


