//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   MonteCarlo                      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//************************************************//
//*        Mc_On_Policy_Evaluation               *//
//************************************************//
function Returns=Mc_On_Policy_Evaluation(Episode, Returns)
  
  // Calcul Q(s,a) au travers de la matrice Returns(:,s,a)
  for turn=1:length(Episode)
  
    t = Mc_First_Occurrence(Episode, 1, turn)
    R = Mdl_Reward(Episode,t)
    
    [state, action] = Mc_Lin_State_Action(Episode(turn))

    Moyenne  = Returns(1,state,action)
    Compteur = Returns(2,state,action)

    Moyenne = (Moyenne*Compteur + R) / (Compteur + 1)

    //Q(s,a) = Returns(1,s,a)
    Returns(1,state,action) = Moyenne
    Returns(2,state,action) = Compteur + 1
    
  end
  
endfunction
//************************************************//

//************************************************//
//*              Mc_On_Policy_Improve            *//
//************************************************//
function Pi=Mc_On_Policy_Improve(Episode, Pi, Q, Actionlist, _epsilon)

  Card_aStar = list()
    
  // calculates the a*
  // allows the generation of a normalized policy
  for turn=1:length(Episode)
  
    [state, action] = Mc_Lin_State_Action(Episode(turn))
    
    Card_aStar(turn) = 0
    Qmax = max(Q(1,state,Actionlist(state)))
    for i=1:length(Actionlist(state))
      action = Actionlist(state)(i)
      if Q(1,state,action) == Qmax then
        Card_aStar(turn) = Card_aStar(turn) + 1
      end
    end
    
  end

  // Updating the policy
  
  for turn=1:length(Episode)
  
    [state, action] = Mc_Lin_State_Action(Episode(turn))
    
    Qmax = max(Q(1,state,Actionlist(state)))
    
    Card_Actionlist = length(Actionlist(state))
    Card_aNoStar = Card_Actionlist - Card_aStar(turn)
    
    if Card_aNoStar > 0 then epsilon = _epsilon, else epsilon = 0, end
    
    for i=1:Card_Actionlist
      action = Actionlist(state)(i)
      if Q(1,state,action) == Qmax then
        Pi(state, action) = (1-epsilon)/Card_aStar(turn)
      else
        Pi(state, action) = epsilon/Card_aNoStar
      end
    end
    
  end
  
endfunction
//************************************************//
