//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   MonteCarlo                      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//***************************************************************//
//*                  Reinforcement Learning                     *//
//*              Off-Policy Monte Carlo Control                 *//
//***************************************************************//

SimulateStr='100'
SimulateStr = x_dialog("Number of episodes to simulate ",SimulateStr);
Simulate=evstr(SimulateStr);

timer();
TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
TK_EvalStr('wm title .pliz_wait ""Off Policy Learning""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
TK_EvalStr('pack .pliz_wait.l -fill both');

for loop=1:Simulate

  //(a) Create an episode
  Episode = Mc_Creat_Episode(PiPrime, Actionlist);

  //(b) Initialization of tau
  tau = Mc_Off_Policy_tau(Episode, Pi_off);

  //(c) Episode Analysis 
  [N, D, Q_off] = Mc_Off_Policy_Evaluation(Episode, tau, PiPrime, N, D, Q_off);

  //(c) Update the policy
  Pi_off = Mc_Off_Policy_Improve(Episode, Pi_off, Q_off, Actionlist);
  TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string((loop/Simulate)*100)+'% done""');
end
TK_EvalStr('.pliz_wait.l configure -text ""Learning completed in '+string(timer())+' seconds""');

//***************************************************************//

