//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   MonteCarlo                      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//
//***************************************************************//
//*                  Reinforcement Learning                     *//
//*              On-Policy Monte Carlo Control                  *//
//***************************************************************//

SimulateStr='100'
SimulateStr = x_dialog("Number of episodes to simulate ",SimulateStr);
Simulate=evstr(SimulateStr);


timer();
TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
TK_EvalStr('wm title .pliz_wait ""On Policy Learning""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
TK_EvalStr('pack .pliz_wait.l -fill both');

for loop=1:Simulate

  //(a) Create an episode
  Episode = Mc_Creat_Episode(Pi_on, Actionlist);

  //(b) Episode analysis 
   Returns = Mc_On_Policy_Evaluation(Episode, Returns);

  //(c) Update the policy
  Pi_on = Mc_On_Policy_Improve(Episode, Pi_on, Returns, Actionlist, epsilon);

  TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string((loop/Simulate)*100)+'% done""');

end


// Training termination - Using the optimale policy (epsilon = 0)
AllEpisode = list();
[NbState, Nbaction] = Mc_Lin_State_Action([_s,_a]);

for i=1:NbState
  for j=1:Nbaction
    AllEpisode( (i-1)*Nbaction +j ) = [ Mc_Matrix_State(i) Mc_Matrix_Action(j) ];
  end
end

Pi_onb = Mc_On_Policy_Improve(AllEpisode, Pi_on, Returns, Actionlist, 0);

sR = size(Returns);
Q_on  = matrix(Returns(1,:,:), sR(2), sR(3));

TK_EvalStr('.pliz_wait.l configure -text ""Learning completed in'+string(timer())+' seconds""');

//***************************************************************//

