//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Windy Grid World demonstration  *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


if MSDOS then
	getf(path+'\methods\td\examples\windygrid\MdL_edit_functions.sci');
else
	getf(path+'/methods/td/examples/WindyGrid/MdL_edit_functions.sci');
end

TK_EvalStr('set types {  {{Scilab Exec}       {.mdl}        } {{All}       {.*}        }}');
TK_EvalStr('set MODEL [tk_getOpenFile -filetypes $types -initialdir $path_tcl/methods/td/examples/windygrid/models ]');
fic=TK_GetVar('MODEL');
exec(fic);

if grid_width==0 | grid_height==0

	if grid_width==0 then
		Title='Wanted Grid Width';
		grid_widthSTR='10';
		grid_widthSTR=x_dialog(Title,grid_widthSTR);
		grid_width=evstr(grid_widthSTR);
	end

	if grid_height==0 then
		Title='Wanted Grid Height';
		grid_heightSTR='10';
		grid_heightSTR=x_dialog(Title,grid_heightSTR);
		grid_height=evstr(grid_heightSTR);
	end

	NbStates=grid_width*grid_height;
	wind_X=zeros(grid_height,grid_width);
	wind_Y=zeros(grid_height,grid_width);
	Actionstates=ones(NbStates,NbActions);
	Term_States=zeros(grid_height,grid_width);
	Obstacles=zeros(grid_height,grid_width);
end

width=400;
height=400;

//clear screen
TK_EvalStr('set children [winfo children .rltoolbox.f]');
TK_EvalStr('foreach i $children {destroy $i}');
TK_EvalStr('set fenetre .rltoolbox.f');

//rewards
TK_EvalStr('set var [frame $fenetre.var -bg darkblue]');

TK_EvalStr('label $var.lrewardGoal -text ""Goal Reward :"" -bg darkblue -fg green');
TK_EvalStr('entry $var.rewardGoal -width 5 -bg darkblue -fg green');
TK_EvalStr('$var.rewardGoal insert 0 '+string(Reward_goal));

TK_EvalStr('label $var.lrewardNormal -text ""Normal Reward :"" -bg darkblue -fg green');
TK_EvalStr('entry $var.rewardNormal -width 5 -bg darkblue -fg green');
TK_EvalStr('$var.rewardNormal insert 0 '+string(Reward_normal));

TK_EvalStr('label $var.lrewardBorder -text ""Border Reward :"" -bg darkblue -fg green');
TK_EvalStr('entry $var.rewardBorder -width 5 -bg darkblue -fg green');
TK_EvalStr('$var.rewardBorder insert 0 '+string(Reward_border));

TK_EvalStr('label $var.lrewardWall -text ""Wall Reward :"" -bg darkblue -fg green');
TK_EvalStr('entry $var.rewardWall -width 5 -bg darkblue -fg green');
TK_EvalStr('$var.rewardWall insert 0 '+string(Reward_wall));

TK_EvalStr('label $var.lrewardCliff -text ""Cliff Reward :"" -bg darkblue -fg green');
TK_EvalStr('entry $var.rewardCliff -width 5 -bg darkblue -fg green');
TK_EvalStr('$var.rewardCliff insert 0 '+string(Reward_cliff));

TK_EvalStr('label $var.lrewardHole -text ""Hole Reward :"" -bg darkblue -fg green');
TK_EvalStr('entry $var.rewardHole -width 5 -bg darkblue -fg green');
TK_EvalStr('$var.rewardHole insert 0 '+string(Reward_hole));

TK_EvalStr('pack $var.lrewardGoal $var.rewardGoal $var.lrewardNormal $var.rewardNormal $var.lrewardBorder $var.rewardBorder $var.lrewardWall $var.rewardWall $var.lrewardCliff $var.rewardCliff $var.lrewardHole $var.rewardHole -side top');


//alpha, beta epsilon
TK_EvalStr('set var2 [frame $fenetre.var2 -bg darkblue]');

TK_EvalStr('label $var2.lAlpha -text ""Alpha :"" -bg darkblue -fg green');
TK_EvalStr('entry $var2.alpha -width 5 -bg darkblue -fg green');
TK_EvalStr('$var2.alpha insert 0 '+string(Alpha));

TK_EvalStr('label $var2.lBeta -text ""Beta :"" -bg darkblue -fg green');
TK_EvalStr('entry $var2.beta -width 5 -bg darkblue -fg green');
TK_EvalStr('$var2.beta insert 0 '+string(Beta));

TK_EvalStr('label $var2.lEpsilon -text ""Epsilon :"" -bg darkblue -fg green');
TK_EvalStr('entry $var2.epsilon -width 5 -bg darkblue -fg green');
TK_EvalStr('$var2.epsilon insert 0 '+string(Epsilon));

TK_EvalStr('pack $var2.lAlpha $var2.alpha $var2.lBeta $var2.beta $var2.lEpsilon $var2.epsilon -side top');

TK_EvalStr('canvas $fenetre.c -width 450 -height 450 -bg green');
TK_EvalStr('set fen2 [frame $fenetre.buttons]');
TK_EvalStr('set fen3 [frame $fenetre.radiobut -background darkblue]');

TK_EvalStr('button $fen2.apply -text Apply -command ""ScilabEval Apply(1)""');
TK_EvalStr('button $fen2.save -text Save -command ""ScilabEval Apply(2)""');
TK_EvalStr('button $fen2.simul -text Simul -command ""ScilabEval Apply(3)""');

TK_EvalStr('radiobutton $fen3.s -text ""Start"" -variable rad_but -value -1');
TK_EvalStr('radiobutton $fen3.f -text ""Finish"" -variable rad_but -value '+string(NORMAL)');
TK_EvalStr('radiobutton $fen3.w -text ""Wall"" -variable rad_but -value '+string(WALL));
TK_EvalStr('radiobutton $fen3.c -text ""Cliff"" -variable rad_but -value '+string(CLIFF));
TK_EvalStr('radiobutton $fen3.h -text ""Hole"" -variable rad_but -value '+string(HOLE));
TK_EvalStr('pack $fen3.s $fen3.f $fen3.w $fen3.c $fen3.h -side left -fill x');

TK_EvalStr('label $fenetre.nom_fic -text $MODEL -bg darkblue -fg yellow');

TK_EvalStr('pack $fen2 $fenetre.nom_fic $fen3 -side bottom');
TK_EvalStr('pack $var $fenetre.c $var2 -side left');
TK_EvalStr('pack $fen2.apply $fen2.save $fen2.simul -side left -fill x');

ecart_x=width/grid_width;
ecart_y=height/grid_height;

//the grid is drawed
for i=1:grid_width
	TK_EvalStr('$fenetre.c create line '+string(ecart_x*i)+' '+string(0)+' '+string(ecart_x*i)+' '+string(height));
	TK_EvalStr('entry $fenetre.e'+string(i)+' -width 3 -fg lightgrey -bg darkblue');
	TK_EvalStr('$fenetre.e'+string(i)+' insert 0 '+string(wind_Y(1,i)));
	TK_EvalStr('$fenetre.c create window '+string(ecart_x/2+(i-1)*ecart_x)+' 420 -window $fenetre.e'+string(i));
end

for i=1:grid_height
	TK_EvalStr('$fenetre.c create line '+string(0)+' '+string(ecart_y*i)+' '+string(width)+' '+string(ecart_y*i));
	TK_EvalStr('entry $fenetre.e'+string(i+grid_width)+' -width 3 -fg lightgrey -bg darkblue');
	TK_EvalStr('$fenetre.e'+string(i+grid_width)+' insert 0 '+string(wind_X(i,1)));
	TK_EvalStr('$fenetre.c create window 425 '+string(ecart_y/2+ecart_y*(i-1))+' -window $fenetre.e'+string(i+grid_width));
end


draw_wind();
s=TD_Mdl_first_state();
if s~=0 then
	Center=Center_calc(s);
	TK_EvalStr('$fenetre.c create oval '+string(Center(1)-ecart_x/2)+' '+string(Center(2)-ecart_y/2)+' '+string(Center(1)+ecart_x/2)+' '+string(Center(2)+ecart_y/2)+' -tag start -fill grey');
end

DRAW_TERM(Term_States);

DRAW_WALL(Obstacles);

DRAW_CLIFF(Obstacles);

DRAW_HOLE(Obstacles);

TK_EvalStr('bind $fenetre.c <1> ""ScilabEval \\\[Term_States,Obstacles,First_State\\\]=DRAW_ELTS(%x,%y)""');

//waiting for the interface to be exited
while %t //wait for toplevel to disapear
      TK_EvalStr('set h [winfo exists $fenetre]');
      if TK_GetVar("h")=='0' then break,end
end
