//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Windy Grid World demonstration  *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

function Pos_center=Center_calc(State)
	Pos_center=zeros(2,1);
	Pos_center(1,1)=ecart_x/2+modulo((State-1),grid_width)*ecart_x;
	Pos_center(2,1)=ecart_y/2+floor((State-1)/grid_width)*ecart_y;
endfunction

function draw_wall(x0,y0,x1,y1)
	TK_EvalStr('$fenetre.c create rectangle '+x0+' '+y0+' '+x1+' '+y1+' -fill darkred -tag wall'+x0+y0);
	TK_EvalStr('$fenetre.c create line '+string(evstr(x0)+ecart_x/4)+' '+y0+' '+string(evstr(x0)+ecart_x/4)+' '+y1+' -width '+string(ecart_x/8)+' -fill lightgrey -tag wall'+x0+y0);
	TK_EvalStr('$fenetre.c create line '+string(evstr(x1)-ecart_x/4)+' '+y0+' '+string(evstr(x1)-ecart_x/4)+' '+y1+' -width '+string(ecart_x/8)+' -fill lightgrey -tag wall'+x0+y0);
	TK_EvalStr('$fenetre.c create line '+x0+' '+string(evstr(y0)+ecart_y/4)+' '+x1+' '+string(evstr(y0)+ecart_y/4)+'  -width '+string(ecart_x/8)+' -fill lightgrey -tag wall'+x0+y0);
	TK_EvalStr('$fenetre.c create line '+x0+' '+string(evstr(y1)-ecart_y/4)+' '+x1+' '+string(evstr(y1)-ecart_y/4)+'  -width '+string(ecart_x/8)+' -fill lightgrey -tag wall'+x0+y0);
endfunction

function draw_cliff(x0,y0,x1,y1)
	TK_EvalStr('$fenetre.c create rectangle '+x0+' '+y0+' '+x1+' '+y1+' -fill black -tag cliff'+x0+y0);
endfunction

function draw_hole(x0,y0,x1,y1)
	TK_EvalStr('$fenetre.c create rectangle '+x0+' '+y0+' '+x1+' '+y1+' -fill black -tag hole'+x0+y0);
	TK_EvalStr('$fenetre.c create oval '+x0+' '+y0+' '+x1+' '+y1+' -fill lightgrey -tag hole'+x0+y0);
endfunction


function draw_wind()
//the wind is drawed
for i=1:NbStates

	line=ceil(i/grid_width);
	column=modulo(i,grid_width);
	if column==0 then
		column=grid_width;
	end

	if wind_Y(line,column)~=0 | wind_X(line,column)~=0 then
		if wind_Y(line,column)~=0 & wind_X(line,column)~=0 then
			width=min((ecart_x/10)*(abs(wind_Y(line,column))+abs(wind_X(line,column)))/2,ecart_x/1.5,ecart_y/1.5);
		elseif wind_Y(line,column)~=0 then
			width=min((ecart_x/10)*abs(wind_Y(line,column)),ecart_x/2);
		else
			width=min((ecart_y/10)*abs(wind_X(line,column)),ecart_y/2);
		end

		Center=Center_calc(i);
		signeY=sign(wind_Y(line,column));
		signeX=sign(wind_X(line,column));
		TK_EvalStr('$fenetre.c create line '+string(Center(1))+' '+string(Center(2))+' '+string(Center(1)+signeX*ecart_x/2)+' '+string(Center(2)+signeY*ecart_y/2)+' -tags wind -arrow last -fill darkblue -width '+string(width));
	end
end
endfunction

function a=mat2string(Mat)
a="\[";
	for i=1:size(Mat,1)
		for j=1:size(Mat,2)
			a=a+" "+string(Mat(i,j));
		end
		a=a+"\n";
	end
a=a+" \];"
endfunction

function Save()
	TK_EvalStr('set OUT [tk_getSaveFile -filetypes $types -initialdir ~/projet/RLtoolbox/methods/td/examples/windygrid/models/ ]');
	TK_EvalStr('set file [open $OUT w]');

	TK_EvalStr('puts $file ""Alpha='+string(Alpha)+';""');
	TK_EvalStr('puts $file ""Beta='+string(Beta)+';""');
	TK_EvalStr('puts $file ""Epsilon='+string(Epsilon)+';""');
	TK_EvalStr('puts $file ""Gamma='+string(Gamma)+';""');


	TK_EvalStr('puts $file ""NORMAL=0;""');
	TK_EvalStr('puts $file ""CLIFF=1;""');
	TK_EvalStr('puts $file ""WALL=2;""');
	TK_EvalStr('puts $file ""HOLE=3;""');
	TK_EvalStr('puts $file ""BORDER=4;""');

	TK_EvalStr('puts $file ""grid_width='+string(grid_width)+';""');
	TK_EvalStr('puts $file ""grid_height='+string(grid_height)+';""');

	TK_EvalStr('puts $file ""NbStates=grid_width*grid_height;""');
	TK_EvalStr('puts $file ""NbActions='+string(NbActions)+';""');

	TK_EvalStr('puts $file ""GAUCHE=1;""');
	TK_EvalStr('puts $file ""BAS=2;""');
	TK_EvalStr('puts $file ""DROITE=3;""');
	TK_EvalStr('puts $file ""HAUT=4;""');

	TK_EvalStr('puts $file ""Reward_goal='+string(Reward_goal)+';""');
	TK_EvalStr('puts $file ""Reward_normal='+string(Reward_normal)+';""');
	TK_EvalStr('puts $file ""Reward_border='+string(Reward_border)+';""');
	TK_EvalStr('puts $file ""Reward_wall='+string(Reward_wall)+';""');
	TK_EvalStr('puts $file ""Reward_cliff='+string(Reward_cliff)+';""');
	TK_EvalStr('puts $file ""Reward_hole='+string(Reward_hole)+';""');

	TK_EvalStr('puts $file ""First_State='+string(First_State)+';""');

	a=mat2string(Term_States);
	TK_EvalStr('puts $file ""Term_States='+a+'""');

	a=mat2string(wind_X);
	TK_EvalStr('puts $file ""wind_X='+a+'""');

	a=mat2string(wind_Y);
	TK_EvalStr('puts $file ""wind_Y='+a+'""');

	a=mat2string(Obstacles);
	TK_EvalStr('puts $file ""Obstacles='+a+'""');

	TK_EvalStr('puts $file ""getf(path+''/methods/td/examples/WindyGrid/Mdl_functions.sci'');""');

	a=mat2string(Actionstates);
	TK_EvalStr('puts $file ""Actionstates='+a+'""');

	TK_EvalStr('close $file');
endfunction

function Apply(MODE)
	wind_X=zeros(grid_height,grid_width);
	wind_Y=zeros(grid_height,grid_width);

	for i=1:grid_width
		TK_EvalStr('set val [$fenetre.e'+string(i)+' get]');
		wind_Y(:,i)=evstr(TK_GetVar('val'));
	end
	for i=1:grid_height
		TK_EvalStr('set val [$fenetre.e'+string(i+grid_width)+' get]');
		wind_X(i,:)=evstr(TK_GetVar('val'));
	end
	TK_EvalStr('$fenetre.c delete wind');

	if MODE==1 then
  		draw_wind();
	else
		draw_wind();
		TK_EvalStr('set val [$var2.alpha get]');
		Alpha=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var2.beta get]');
		Beta=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var2.epsilon get]');
		Epsilon=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var.rewardGoal get]');
		Reward_goal=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var.rewardBorder get]');
		Reward_border=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var.rewardNormal get]');
		Reward_normal=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var.rewardCliff get]');
		Reward_cliff=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var.rewardWall get]');
		Reward_wall=evstr(TK_GetVar('val'));

		TK_EvalStr('set val [$var.rewardHole get]');
		Reward_hole=evstr(TK_GetVar('val'));

		if MODE==2
			Save();
		elseif MODE==3
			Simul();
		end
	end
endfunction

function Simul()
	Title='Choose an algorithm';
	Items = ['TD Sarsa' 'Q_Learning' 'R_learning'];
	_algo = x_choose(Items,Title);

	NbEpisodesSTR='500';
	NbEpisodesSTR=x_dialog('Number of episodes to simulate? '+string(NbEpisodesSTR)+' may take sometimes about 15 min.',NbEpisodesSTR);
	NbEpisodes=evstr(NbEpisodesSTR);
	if MSDOS then
		getd(path+'\METHODS\TD\Functions\');
	else
		getd(path+'/methods/td/functions/');
	end

	if _algo==1 then
		Q=TD_Sarsa(NbEpisodes,Actionstates,NbStates,NbActions,Alpha,Gamma,Epsilon);
	elseif _algo==2
		Q=TD_Q_learning(NbEpisodes,Actionstates,NbStates,NbActions,Alpha,Gamma,Epsilon);
	elseif _algo==3
		NbIterations=NbEpisodes;
		Q=TD_R_learning(NbIterations,Actionstates,NbStates,NbActions,Alpha,Beta,Epsilon);
	end
	if MSDOS then
		exec(path+'\methods\td\examples\WindyGrid\Display_res.sce');
	else
		exec(path+'/methods/td/examples/WindyGrid/Display_res.sce');
	end
endfunction

function First_State=SetStart(x,y)

	x0=floor(x/ecart_x)*ecart_x;
	y0=floor(y/ecart_y)*ecart_y;

	x1=ceil(x/ecart_x)*ecart_x;
	y1=ceil(y/ecart_y)*ecart_y;

	if x0==x1 | y0==y1
		return
	end

	TK_EvalStr('$fenetre.c delete start');

	First_State=floor(y/ecart_y)*grid_width+floor(x/ecart_x)+1;

	TK_EvalStr('$fenetre.c create oval '+string(x0)+' '+string(y0)+' '+string(x1)+' '+string(y1)+' -tag start -fill grey');
endfunction

function Export()
	TK_EvalStr('set types2 {  {{PostScript}       {.ps}        } }');
	TK_EvalStr('set EXPORT [tk_getSaveFile -filetypes $types2 -initialdir $path_tcl/methods/td/examples/WindyGrid/results/ -initialfile res.ps] ');
	TK_EvalStr('$fenetre.c postscript -file $EXPORT');
endfunction

function draw_term(x0,y0,x1,y1)
	TK_EvalStr('$fenetre.c create oval '+x0+' '+y0+' '+x1+' '+y1+' -fill yellow -tag finish'+x0+y0);
endfunction

function DRAW_TERM(Term_States)
//attention find pour une matrice 2d inverse lignes et col
s_end=find(Term_States'==1);
for i=1:size(s_end,2)
	s_tmp=s_end(1,i);
	Center=Center_calc(s_tmp);
	draw_term(string(Center(1)-ecart_x/2),string(Center(2)-ecart_y/2),string(Center(1)+ecart_x/2),string(Center(2)+ecart_y/2));
end
endfunction

function DRAW_WALL(Obstacles)
//attention find pour une matrice 2d inverse lignes et col
s_WALL=find(Obstacles'==WALL);
if size(s_WALL,1)~=0
	for i=1:size(s_WALL,2)
		s_tmp=s_WALL(1,i);
		Center=Center_calc(s_tmp);
		draw_wall(string(Center(1)-ecart_x/2),string(Center(2)-ecart_y/2),string(Center(1)+ecart_x/2),string(Center(2)+ecart_y/2));
	end
end
endfunction

function DRAW_CLIFF(Obstacles)
//attention find pour une matrice 2d inverse lignes et col
s_CLIFF=find(Obstacles'==CLIFF);
if size(s_CLIFF,1)~=0
	for i=1:size(s_CLIFF,2)
		s_tmp=s_CLIFF(1,i);
		Center=Center_calc(s_tmp);
		draw_cliff(string(Center(1)-ecart_x/2),string(Center(2)-ecart_y/2),string(Center(1)+ecart_x/2),string(Center(2)+ecart_y/2));
	end
end
endfunction

function DRAW_HOLE(Obstacles)
//attention find pour une matrice 2d inverse lignes et col
s_HOLE=find(Obstacles'==HOLE);
if size(s_HOLE,1)~=0
	for i=1:size(s_HOLE,2)
		s_tmp=s_HOLE(1,i);
		Center=Center_calc(s_tmp);
		draw_hole(string(Center(1)-ecart_x/2),string(Center(2)-ecart_y/2),string(Center(1)+ecart_x/2),string(Center(2)+ecart_y/2));
	end
end
endfunction

function Retour=SetElts(x,y,Elts_States,Elts)

	Retour=Elts_States;

	x0=floor(x/ecart_x)*ecart_x;
	y0=floor(y/ecart_y)*ecart_y;

	x1=ceil(x/ecart_x)*ecart_x;
	y1=ceil(y/ecart_y)*ecart_y;

	if x0==x1 | y0==y1 then
		return
	end


	if Retour(ceil(y/ecart_y),ceil(x/ecart_x))~=0 then
		select Elts
			case NORMAL then TK_EvalStr('$fenetre.c delete finish'+string(x0)+string(y0));
			case WALL then TK_EvalStr('$fenetre.c delete wall'+string(x0)+string(y0));
			case CLIFF then TK_EvalStr('$fenetre.c delete cliff'+string(x0)+string(y0));
			case HOLE then TK_EvalStr('$fenetre.c delete hole'+string(x0)+string(y0));
		end
		Retour(ceil(y/ecart_y),ceil(x/ecart_x))=0;
	else
		if Elts~=0 then
			Retour(ceil(y/ecart_y),ceil(x/ecart_x))=Elts;

			select Elts
				case CLIFF then draw_cliff(string(x0),string(y0),string(x1),string(y1));
				case WALL then draw_wall(string(x0),string(y0),string(x1),string(y1));
				case HOLE then draw_hole(string(x0),string(y0),string(x1),string(y1));
			end
		else
			Retour(ceil(y/ecart_y),ceil(x/ecart_x))=1;
			draw_term(string(x0),string(y0),string(x1),string(y1));
		end
	end
endfunction

function [TS,O,FS]=DRAW_ELTS(x,y)
	a=evstr(TK_GetVar('rad_but'));
	//-1 fort start elt
	if a==-1 then
		FS=SetStart(x,y);
		O=Obstacles;
		TS=Term_States;
	elseif a==NORMAL
		TS=SetElts(x,y,Term_States,a);
		O=Obstacles;
		FS=First_State;
	else
		O=SetElts(x,y,Obstacles,a);
		TS=Term_States;
		FS=First_State;
	end

endfunction
