//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Random Walk demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//TD model: load.sce

//Only pdarkrediction
Alpha=0.1;
Gamma=1; //episodic
NbStates=7;
NbActions=2;

if MSDOS then
	getf(path+'\methods\td\examples\RandomWalk\Mdl_functions.sci');
	getf(path+'\methods\td\examples\RandomWalk\MC_alpha_cste.sci');
else
	getf(path+'/methods/td/examples/randomWalk/Mdl_functions.sci');
	getf(path+'/methods/td/examples/randomWalk/MC_alpha_cste.sci');
end

//on efface l'ecran
TK_EvalStr('set children [winfo children .rltoolbox.f]');
TK_EvalStr('foreach i $children {destroy $i}');


if _algo==1 then
	NbEpisodesSTR='100';
	NbEpisodesSTR=x_dialog('Number of episodes to simulate',NbEpisodesSTR);
	NbEpisodes=evstr(NbEpisodesSTR);

	[V,Mem]=TD_nonbatch_prediction(NbEpisodes,NbStates,NbActions,Alpha,Gamma);
	V_MC=MC_alpha_constant(NbEpisodes,NbStates,NbActions,Alpha,Gamma);

	V=V([2:6],1);
	V_MC=V_MC([2:6],1);

	TK_EvalStr('label .rltoolbox.f.iout'+string(0)+' -image [image create photo -file ""$path_tcl/methods/td/examples/randomWalk/images/outg.gif""]');
	TK_EvalStr('label .rltoolbox.f.i'+string(0)+' -image [image create photo -file ""$path_tcl/methods/td/examples/randomWalk/images/1.gif""]');
	TK_EvalStr('pack .rltoolbox.f.iout'+string(0)+' .rltoolbox.f.i'+string(0)+' -side left');
	ETATS=['A :\n' 'B :\n' 'C :\n' 'D :\n' 'E :\n'];
	for i=1:NbStates-2,//on ne tient pas compte des etats finaux
		TK_EvalStr('label .rltoolbox.f.l'+string(i)+'  -fg darkblue -bg darkred -text ""'+ETATS(i)+string(round(V(i)*100)/100)+'""');
		if i~=NbStates-2 //pour la sortie on ne peut y aller qu'a droite
			TK_EvalStr('label .rltoolbox.f.i'+string(i)+' -image [image create photo -file ""$path_tcl/methods/td/examples/randomWalk/images/13.gif""]');
		else
			TK_EvalStr('label .rltoolbox.f.i'+string(i)+' -image [image create photo -file ""$path_tcl/methods/td/examples/randomWalk/images/3.gif""]');
		end
		TK_EvalStr('pack .rltoolbox.f.l'+string(i)+' .rltoolbox.f.i'+string(i)+' -side left');
	end

	TK_EvalStr('label .rltoolbox.f.iout'+string(NbStates-1)+' -image [image create photo -file ""$path_tcl/methods/td/examples/randomWalk/images/outd.gif""]');
	TK_EvalStr('pack .rltoolbox.f.iout'+string(NbStates-1)+' -side left');

	for i=1:3
		Mem(i)=Mem(i)([2:6],1);
	end

	T=[1:5];
	T=T/6;
	T=T';
	E=V-T;
	E_MC=V_MC-T;
	E1=Mem(1)-T;
	E2=Mem(2)-T;


	xbasc();
	legende="V(s) Thorique@V(s) "+string(round(NbEpisodes/3))+" Episodes@V(s) "+string(round(NbEpisodes/3)*2)+" Episodes @V(s) "+NbEpisodesSTR+" Episodes";

	xsetech([0,0,0.5,0.5]);
	xtitle('Variation of V(s) for TD prediction');
	plot2d([1:5],[T Mem(1) Mem(2) V],,,legende);
	xsetech([0.5,0,0.5,0.5]);
	xtitle('Comparaison between Td prediction and MC-alpha-cste');
	plot2d([1:5],[T V V_MC ],,,"V(s) theoric@V(s) TD@V(s) MC-alpha-cste");
	xsetech([0,0.5,0.5,0.5]);
	xtitle('V(s) Error for TD prediction');
	plot2d([1:5],[E1 E2 E],,,"E"+string(round(NbEpisodes/3))+"@E"+string(round(NbEpisodes/3)*2)"+"@E");
	xsetech([0.5,.5,0.5,0.5]);
	xtitle('Error for TD prediction and MC-alpha-cste');
	plot2d([1:5],[E E_MC],,,"E_TD@E_MC");

	TK_EvalStr('tk_messageBox -title ""Max error"" -message ""The maximum error with the theorical values is '+string(max(abs(E)))+'"" -type ok');
end




