//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

// appendtrainingdata.m - updates lookuptables
// approach adopted from Sebastian Siegel,ece539, 11/13/2001, 12/15/2001
// calls framevaule.m, getframeprob.m, setframeprob.m
// input: called from generatelookuptable.m
// output: none (lookuptables are updated)
function [temp,lookuptablepos,lookuptableneg]=append_trainingdata(m)

[moveslength,temp]=size(moves);
moveslength=moveslength-1; // last entry contains the winner
if winner == 0,
  frameprobpos=drawprob;
  frameprobneg=drawprob;
elseif winner == 1,
  frameprobpos=1;
  frameprobneg=0;
else
  frameprobpos=0;
  frameprobneg=1;
end


// initial frameprobs
[sumposcurrent,sumnegcurrent]=framevalue(m);
if player==-1,
  [line,temp]=getframeprob(lookuptableneg,sumposcurrent,sumnegcurrent); // just to get "line"
  lookuptableneg=setframeprob(lookuptableneg,sumposcurrent,sumnegcurrent,frameprobneg,line);
  m(moves(moveslength,1),moves(moveslength,2))=0;	// clear neg's last move
  [sumposcurrent,sumnegcurrent]=framevalue(m);   
  [line,temp]=getframeprob(lookuptablepos,sumposcurrent,sumnegcurrent); // just to get "line"
  lookuptablepos=setframeprob(lookuptablepos,sumposcurrent,sumnegcurrent,frameprobpos,line);
else
  [line,temp]=getframeprob(lookuptablepos,sumposcurrent,sumnegcurrent); // just to get "line"
  lookuptablepos=setframeprob(lookuptablepos,sumposcurrent,sumnegcurrent,frameprobpos,line);
  m(moves(moveslength,1),moves(moveslength,2))=0;	// clear pos's last move
  [sumposcurrent,sumnegcurrent]=framevalue(m);
  [line,temp]=getframeprob(lookuptableneg,sumposcurrent,sumnegcurrent); // just to get "line"
  lookuptableneg=setframeprob(lookuptableneg,sumposcurrent,sumnegcurrent,frameprobneg,line);
end

// now: both final frames are stored, the very last move is removed

if winner==0, // draw
  mtemp=m;
  mtemp(moves(moveslength-1,1),moves(moveslength-1,2))=0;	// clear 2nd last move
  for i=moveslength-2:-1:1,
    [sumposcurrent,sumnegcurrent]=framevalue(mtemp);
    if moves(i,3)==-1,
      currentframeprobneg=frameprobneg;
      [line,frameprobneg]=getframeprob(lookuptableneg,sumposcurrent,sumnegcurrent);
      frameprobneg=frameprobneg+alpha*(currentframeprobneg-frameprobneg);
      lookuptableneg=setframeprob(lookuptableneg,sumposcurrent,sumnegcurrent,frameprobneg,line);
      mtemp(moves(i,1),moves(i,2))=0;	// clear neg's move
    else

      currentframeprobpos=frameprobpos;
      [line,frameprobpos]=getframeprob(lookuptablepos,sumposcurrent,sumnegcurrent);
      frameprobpos=frameprobpos+alpha*(currentframeprobpos-frameprobpos);
      lookuptablepos=setframeprob(lookuptablepos,sumposcurrent,sumnegcurrent,frameprobpos,line);
      mtemp(moves(i,1),moves(i,2))=0;	// clear pos's move
    end
  end
else // somone won
  mtemp=m;
  mtemp(moves(moveslength-1,1),moves(moveslength-1,2))=0;	// clear 2nd last move
  for i=moveslength-2:-1:1,
    [sumposcurrent,sumnegcurrent]=framevalue(mtemp);   
    if moves(i,3)==winner,
      if moves(i,3)==-1, 
	currentframeprobneg=frameprobneg;
	[line,frameprobneg]=getframeprob(lookuptableneg,sumposcurrent,sumnegcurrent);
	frameprobneg=frameprobneg+alpha*(currentframeprobneg-frameprobneg);
	lookuptableneg=setframeprob(lookuptableneg,sumposcurrent,sumnegcurrent,frameprobneg,line);
	mtemp(moves(i,1),moves(i,2))=0;	// clear neg's move
      else
	currentframeprobpos=frameprobpos;
	[line,frameprobpos]=getframeprob(lookuptablepos,sumposcurrent,sumnegcurrent);
	frameprobpos=frameprobpos+alpha*(currentframeprobpos-frameprobpos);
	lookuptablepos=setframeprob(lookuptablepos,sumposcurrent,sumnegcurrent,frameprobpos,line);
	mtemp(moves(i,1),moves(i,2))=0;	// clear pos's move
      end
    else
      if moves(i,3)==-1,
	if donotlearnneg(i+2)==0,
	  currentframeprobneg=frameprobneg;
	  [line,frameprobneg]=getframeprob(lookuptableneg,sumposcurrent,sumnegcurrent); 
	  frameprobneg=frameprobneg+alpha*(currentframeprobneg-frameprobneg);
	  lookuptableneg=setframeprob(lookuptableneg,sumposcurrent,sumnegcurrent,frameprobneg,line);
	else
	  [line,frameprobneg]=getframeprob(lookuptableneg,sumposcurrent,sumnegcurrent); //read frameprobneg
	end
	mtemp(moves(i,1),moves(i,2))=0;	// clear neg's move
      else
	if donotlearnpos(i+2)==0,
	  currentframeprobpos=frameprobpos;
	  [line,frameprobpos]=getframeprob(lookuptablepos,sumposcurrent,sumnegcurrent); 
	  frameprobpos=frameprobpos+alpha*(currentframeprobpos-frameprobpos);
	  lookuptablepos=setframeprob(lookuptablepos,sumposcurrent,sumnegcurrent,frameprobpos,line);
	else
	  [line,frameprobpos]=getframeprob(lookuptablepos,sumposcurrent,sumnegcurrent); //read frameprobpos
	end
	mtemp(moves(i,1),moves(i,2))=0;	// clear pos's move
      end
    end
  end
end
