//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

function benchmark()
	draw_games=0;

	win_player1=0;
	win_player2=0;

	lose_player1=0;
	lose_player2=0;

	//we load the lookuptables for the 2 players
	TK_EvalStr('set types {  {{Scilab Data}       {.dat}        } {{All}       {.*}        }}');
	TK_EvalStr('set MODEL [tk_getOpenFile -filetypes $types -initialdir $path_tcl/methods/td/examples/tic_tac_toe/lookuptables ]');
	fic=TK_GetVar('MODEL');
	load(fic);
	lookuptable1neg=lookuptableneg;


	TK_EvalStr('set fenetre1 [frame .rltoolbox.f.1 -bg darkblue]');
	TK_EvalStr('label $fenetre1.lw1 -text ""Games win by player 1 :\n'+string(win_player1)+'"" -bg darkblue -fg green');
	TK_EvalStr('label $fenetre1.ll1 -text ""Games lose by player 1:\n'+string(lose_player1)+'"" -bg darkblue -fg green');
	TK_EvalStr('label $fenetre1.lfic -text ""[file tail $MODEL]"" -bg darkblue -fg yellow');
	TK_EvalStr('pack $fenetre1.lfic $fenetre1.lw1 $fenetre1.ll1 -side top -expand 1');

	TK_EvalStr('set types {  {{Scilab Data}       {.dat}        } {{All}       {.*}        }}');
	TK_EvalStr('set MODEL [tk_getOpenFile -filetypes $types -initialdir $path_tcl/methods/td/examples/tic_tac_toe/lookuptables ]');
	fic=TK_GetVar('MODEL');
	load(fic);
	lookuptableneg=lookuptable1neg;

	TK_EvalStr('set fenetre2 [frame .rltoolbox.f.2 -bg darkblue]');
	TK_EvalStr('label $fenetre2.lw2 -text ""Games win by player 2:\n'+string(win_player2)+'"" -bg darkblue -fg green');
	TK_EvalStr('label $fenetre2.ll2 -text ""Games lose by player 2:\n'+string(lose_player2)+'"" -bg darkblue -fg green');
	TK_EvalStr('label $fenetre2.lfic -text ""[file tail $MODEL]"" -bg darkblue -fg yellow');
	TK_EvalStr('pack $fenetre2.lfic $fenetre2.lw2 $fenetre2.ll2 -side top -expand 1 ');

	TK_EvalStr('label .rltoolbox.f.ld -text ""Draw Games :\n'+string(draw_games)+'"" -bg darkblue -fg green');
	TK_EvalStr('pack .rltoolbox.f.ld -side bottom');
	TK_EvalStr('pack $fenetre1 $fenetre2 -side left -fill x -expand 1');


	simulations=evstr(x_dialog('Number of games to launch ?','200'));

	Victoires=zeros(simulations,1);
	Defaites=zeros(simulations,1);
	Egalites=zeros(simulations,1);


	TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
	TK_EvalStr('toplevel .pliz_wait');
	TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
	TK_EvalStr('wm title .pliz_wait ""Benchmark""');
	TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
	TK_EvalStr('pack .pliz_wait.l -fill both');
	timer();

	for i=1:simulations
		winner=ones(1,2)*99;
		cptr=0;
		player=round(rand()*2)-1;//random player at the begining
		m=zeros(dr,dc);
		while winner(1)~=-1 & winner(2)~=-1 & cptr<dr*dc
			cptr=cptr+1;
			suggest_index=dr*dc;
			if player==1 then
				suggest=comp_table(m,player,0,lookuptablepos);
			else
				suggest=comp_table(m,player,0,lookuptableneg);
			end
			while m(suggest(1,suggest_index),suggest(2,suggest_index))~=0,  // if the target is occupied
           			suggest_index=suggest_index-1;				// then take the next choice
			end
			r=suggest(1,suggest_index);
	       		c=suggest(2,suggest_index);
			m(r,c)=player;
			player=-player;

			//test if a player wins
			[winner,m2]=winnertest_preframes(m,mc,dwin);
			if winner(1)==-1
				win_player1=win_player1+1;
				lose_player2=lose_player2+1;
				TK_EvalStr('.rltoolbox.f.1.lw1 configure -text ""Games win by player 1:\n'+string(win_player1)+'""');
				TK_EvalStr('.rltoolbox.f.2.ll2 configure -text ""Games lose by player 2 :\n'+string(lose_player2)+'""');
			elseif winner(2)==-1
				win_player2=win_player2+1;
				lose_player1=lose_player1+1;
				TK_EvalStr('.rltoolbox.f.2.lw2 configure -text ""Games win by player 2:\n'+string(win_player2)+'""');
				TK_EvalStr('.rltoolbox.f.1.ll1 configure -text ""Games lose by player 1 :\n'+string(lose_player1)+'""');
			end
		end
		//if nobody wins
		if winner(1)~=-1 & winner(2)~=-1
			draw_games=draw_games+1;
			TK_EvalStr('.rltoolbox.f.ld configure -text ""Draw Games :\n'+string(draw_games)+'""');
		end
		Victoires(i)=(win_player1/i)*100;
		Defaites(i)=(lose_player1/i)*100;
		Egalites(i)=(draw_games/i)*100;

		xbasc();
		xclear();
		xtitle('Evolution of games won ','Number of''games','Percentage');
		plot2d([1:i],[Victoires([1:i]) Egalites([1:i]) Defaites([1:i])],,,'Games Won by player 1@Draw games@Games won by player 2');
		TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string(round(10000*i/simulations)/100)+'% done""');
	end
	TK_EvalStr('.pliz_wait.l configure -text ""Benchmark completed in '+string(timer())+' seconds""');
endfunction
