//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


function tk_generate_lookuptable()
TK_EvalStr('set types {  {{Scilab Data}       {.dat}        } {{All}       {.*}        }}');
TK_EvalStr('set MODEL [tk_getSaveFile -filetypes $types -initialdir $path_tcl/methods/td/examples/tic_tac_toe/lookuptables ]');
fic=TK_GetVar('MODEL');

TK_EvalStr('set main .rltoolbox.f');
TK_EvalStr('set val [$main.f1.e get]');
drawprob = evstr(TK_GetVar('val'));		 // reward for a draw (between lose=0 and win=1)

TK_EvalStr('set main .rltoolbox.f');
TK_EvalStr('set val [$main.f2.e get]');
learnparameter=evstr(TK_GetVar('val'));	; // step-size parameter (updates the P-values)

TK_EvalStr('set main .rltoolbox.f');
TK_EvalStr('set val [$main.f3.e get]');
randomlearnparameter=evstr(TK_GetVar('val')); // in percent, 0 = no random moves at all

TK_EvalStr('set main .rltoolbox.f');
TK_EvalStr('set val [$main.f4.e get]');
games=evstr(TK_GetVar('val'));					// games to play

generate_lookuptable(fic,drawprob,learnparameter,randomlearnparameter,games);

endfunction

function generate_lookuptable(fic,drawprob,learnparameter,randomlearnparameter,games)
winnerpos=0;	//statistics
winnerneg=0;	//statistics
winnerdraw=0;  //statistics
lookuptablepos=[0 0 .5];	// initializes lookup table for player (X)
lookuptableneg=[0 0 .5];	// initializes lookup table for player (O)

contin=games;

Results=zeros(games/10,6);

TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
TK_EvalStr('wm title .pliz_wait ""Training""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
TK_EvalStr('pack .pliz_wait.l -fill both');
timer();

while contin~=0;
  m=zeros(dr,dc); // initializes the matrix that contains the current frame
  spotsleft=dr*dc; // initilaizes the number of total turns
  player=round(rand())*2-1; // randomly selects if the ANN is either player -1 or +1
  moves=zeros(0,3); // initializes a matrix that keeps track of every single move ...
      //    and the winner
  donotlearnpos=zeros(1,dr*dc); // later: ones will indicate random moves
  donotlearnneg=zeros(1,dr*dc); // later: ones will indicate random moves
  alpha=learnparameter*contin/games; // learning rate
  winner=99;
  while winner==99,
    suggest_index=dr*dc;
    player=-player;
    if player==-1,			// playerneg input
      if rand() < randomlearnparameter,
	donotlearnneg(dr*dc-spotsleft+1)=1;
	randomsuggest=1;
      else
	randomsuggest=0;
      end
      suggest=comp_table(m,player,randomsuggest,lookuptableneg);   // get move from lookup table
      while m(suggest(1,suggest_index),suggest(2,suggest_index))~=0, // target has a mark
	suggest_index=suggest_index-1; 	// take the next choice
      end
      r=suggest(1,suggest_index);
      c=suggest(2,suggest_index);
    else 			// playerpos input
      if rand(1) < randomlearnparameter,
	donotlearnpos(dr*dc-spotsleft+1)=1;
	randomsuggest=1;
      else
	randomsuggest=0;
      end
      suggest=comp_table(m,player,randomsuggest,lookuptablepos);  // get move from lookup table
      while m(suggest(1,suggest_index),suggest(2,suggest_index))~=0,  // target has a mark
	suggest_index=suggest_index-1;		// take the next choice
      end
      r=suggest(1,suggest_index);
      c=suggest(2,suggest_index);
    end
    moves=[moves; r, c, player];
    m(r,c)=player;
    spotsleft=spotsleft-1;
    winner=winnertest(m,mc,player,spotsleft,dwin);

  end
  TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string(round(10000*(games-contin)/games)/100)+'% done""');
  contin=contin-1;
  moves(dr*dc-spotsleft+1,:)=[0,0,winner];

  // statistics:
  if winner==1,
    winnerpos=winnerpos+1;
  elseif winner==-1,
    winnerneg=winnerneg+1;
  else
    winnerdraw=winnerdraw+1;
  end

[temp,lookuptablepos,lookuptableneg]=append_trainingdata(m);


// statistics:
if (modulo(contin,10)==0),
  [trainsizepos,temp]=size(lookuptablepos);
  [trainsizeneg,temp]=size(lookuptableneg);


 Results((games-contin)/10,:)=[contin winnerpos winnerdraw winnerneg trainsizepos trainsizeneg];
 printf("%s\n",string(contin)+ ';  ---   '+string(winnerpos)+ ';  ' +string(winnerdraw)+ ';  ' +string(winnerneg) + ';  ---  '+string(trainsizepos)+ '; / '+string(trainsizeneg));
 Stats(Results,contin);

  if (modulo(contin,100)==0),
   	save(path+'/methods/td/examples/tic_tac_toe/lookuptables/tmp/trainingdata.dat', lookuptablepos, lookuptableneg);
  end
end

end
save(fic, lookuptablepos, lookuptableneg);
TK_EvalStr('.pliz_wait.l configure -text ""Simulation completed in '+string(timer())+' seconds""');
endfunction
