//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


// getframeprob.m - returns the P-value for a state or 0.5 of unknown
//                  also: returns the line number of the entry or -1 if unknown
// approach adopted from Sebastian Siegel, ece539, 11/23/2001, 12/15/2001
// input: lookup table, S(X), S(O)
// output: [line, P-value]
// lookup table needs to be sorted (first column and then second column)

function [line,frameprob]=getframeprob(train,sumpos,sumneg);
[trainlength,temp]=size(train);
for i = 1 : trainlength,

   if train(i,1)==sumpos // S(X) found

    if train(i,2)==sumneg, // S(O) found as well

      line=i;
      frameprob=train(i,3);

      return
    end
  elseif train(i,1)>sumpos, // S(X) will not be found

    line=-1;
    frameprob=.5;
    return
  end
end
// search unsuccesful => no entry for the given state exists
line=-1;
frameprob=.5;
endfunction
