//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


// init_mc.m - creates matrix mc that will know the
//               directions to check for 4 in a row for every single spot
// approach adopted from Sebastian Siegel, ece539, 10/26/2001
// input: NOT A FUNCTION! dr, dc, dwin are global variables
//        dr,dc ... size of field
//        dwin ... number of marks that indicate a winner
// output: mc (global variable)
// code for the spots of mc:
//    0 : no check necessery
//    1 : SW, S, SE, E
//    2 : S, SE, E
//    3 : SW, S
//    4 : S
//    5 : E
function mc=init_mc(dr,dc)
mc=ones(dr,dc); //initializes mc
for r=1:dr,
   for c=1:dc,
      if dc-c<(dwin-1), // must remove E, SE: 1->3, 2->4, 5->0
         if mc(r,c)==1,
            mc(r,c)=3;
         end
         if mc(r,c)==2,
            mc(r,c)=4;
         end
         if mc(r,c)==5,
            mc(r,c)=0;
         end
      end
      if c<dwin, // must remove SW: 1->2, 3->4
         if mc(r,c)==1,
            mc(r,c)=2;
         end
         if mc(r,c)==3,
            mc(r,c)=4;
         end
      end
      if dr-r<(dwin-1), // must remove S, SE, SW: 1->5, 2->5, 3->0, 4->0
         if mc(r,c)==1 | mc(r,c)==2,
            mc(r,c)=5;
         end
         if mc(r,c)==3 | mc(r,c)==4,
            mc(r,c)=0;
         end
      end
   end
end
endfunction