//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


// setframeprob.m - appends the lookup table by a state and the corresponding V-value
// 				       or updates an existing V-value
// approach adopted from Sebastian Siegel, ece539,11/23/2001, 12/15/2001
// IMPORTANT: getframevalue(...) must be run before this function is called to get "line"
//            because this function assumes that there is no entry for a given state yet if
//            line == -1
//
// 				 lookup table remains sorted (first column in ascending oder 
//                                         and then second column in ascending order)
//
// input: lookup table, S(X), S(O), P-value, line
// output: new lookup table

function train=setframeprob(train_input,sumpos,sumneg,frameprob,line)
train=train_input;
if line ~= -1, // only update necessary, state in known to lookup table
  train(line,:)=[sumpos, sumneg, frameprob];
  return
end
// need to append lookup table by new entry (makes sure that lookup table remains sorted)
[trainlength,temp]=size(train);
for i = 1 : trainlength,
  if train(i,1)==sumpos,
    if train(i,2)>sumneg,
      train(i+1:trainlength+1,:)=train(i:trainlength,:);
      train(i,:)=[sumpos, sumneg, frameprob];
      return
    end
  elseif train(i,1)>sumpos,
    train(i+1:trainlength+1,:)=train(i:trainlength,:);
    train(i,:)=[sumpos, sumneg, frameprob];
    return
  end
end

train(trainlength+1,:)=[sumpos, sumneg, frameprob];

endfunction
