//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


// tvtest.m - tests a vector whether it represents that someone won or if there 
//              is still a chance for someone to win in these spots
// approach adopted from Sebastian Siegel, ece539, 10/26/2001, 11/24/2001
// input: tv ... testvector
//        winner ... status of current winners so far
// output: winner
// code for winner:
//    99 		: so far, there is no chance for x to win the game
//    1..4  	: there is still a chance for x to win in n remaining turns for him
//    -1 		: player x won

function winner=tvtest(tv,winner,dwin),
if winner(1)==-1 | winner(2)==-1, 	// makes sure, that ones a winner is found, the ...
   return                  			// information is not overwritten by the first following if                             
end
winner_new=max(tv)+min(tv);
select winner_new
case -2 then
   winner=[-1,winner(2)]; 					// player -1 won
case -1 then
   winner=[min([winner(1),dwin-sum(abs(tv))]),winner(2)];
case 0 then
   if sum(abs(tv)) == 0,
      winner=[min(winner(1),dwin),min(winner(2),dwin)];      
   end
case 1 then
   winner=[winner(1),min([winner(2),dwin-sum(abs(tv))])];
case 2 then
   winner=[winner(1),-1]; 					// player 1 won
 end
 
endfunction
