//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


// winnertest.m - tests the input matrix m if someone won the game or if there 
//                   is still a chance for someone to win the game
// approach adopted from Sebastian Siegel, ece539, 10/26/2001, 12/15/2001
// calls: tvtest.m
// input: m ... field of the game
//        mc ... matrix containing the directions to check for matrix m
//			player (whose turn it is)
//			spotsleft (# of empty squares on the board)
//			dwin
// output: winner
// code for winner:
//    99 : there is still a chance for someone to win
//    +1 : player +1 won
//   -1 : player -1 won
//    0  : game will end as a draw
// attention: the output of tvtest 
// is also a variable called "winner" that differs, 
//					see "tvtest.m" for details

function winner=winnertest(m,mc,player,spotsleft,dwin),
[dr,dc]=size(mc);             // stores the size of mc
winner=[99,99];               // initializes winner
tv=zeros(1,dwin);					// initializes tv
for r=1:dr,
  for c=1:dc,
    if winner(1) == -1,		// winner found (-1 won)
      winner = -1;
      return
    end
    if winner(2) == -1,    	// winner found (+1 won)
      winner = 1; 
      return
    end
    select mc(r,c) // check, if someone can still win the game, or if someone won already
    case 0 then
      // no action necessary
    case 1 then
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c-i); // SW
      end
      winner=tvtest(tv,winner,dwin);
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c); // S 
      end
      winner=tvtest(tv,winner,dwin);
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c+i); // SE
      end
      winner=tvtest(tv,winner,dwin);
      for i=0:dwin-1,
	tv(i+1)=m(r,c+i); // E
      end
      winner=tvtest(tv,winner,dwin);
    case 2 then
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c); // S
      end
      winner=tvtest(tv,winner,dwin);
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c+i); // SE
      end
      winner=tvtest(tv,winner,dwin);
      for i=0:dwin-1,
	tv(i+1)=m(r,c+i); // E
      end
      winner=tvtest(tv,winner,dwin);
    case 3 then
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c-i); // SW
      end
      winner=tvtest(tv,winner,dwin);
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c); // S
      end
      winner=tvtest(tv,winner,dwin);
    case 4 then
      for i=0:dwin-1,
	tv(i+1)=m(r+i,c); // S
      end
      winner=tvtest(tv,winner,dwin);
    case 5 then
      for i=0:dwin-1,
	tv(i+1)=m(r,c+i); // E
      end
      winner=tvtest(tv,winner,dwin);
    end
  end
end
if min(winner)<99,
  select player,
  case 1 then
    if (winner(1)-1)*2<spotsleft | winner(2)*2<=spotsleft,
      winner = 99;							// noone won yet
      return
    end
  case -1 then
    if (winner(2)-1)*2<spotsleft | winner(1)*2<=spotsleft,
      winner = 99;							// noone won yet
      return
    end
  end
end   
winner = 0;											// draw
endfunction