//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   Tic_Tac_Toe demonstration	      *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//


// winnertest_preframes.m - tests the input matrix m if someone won and removes the 
//				   			   winnning row in such a case
// approach adopted from Sebastian Siegel, ece539, 10/26/2001, 12/15/2001
// calls: tvtest.m
// input: m ... field of the game
//        mc ... matrix containing the directions to check for matrix m
//        dwin ... length of marks in a row that indicate a winner
// output: m ... the winning row is removed !!!
//	       winner
// code for winner:
//    99 : there is still a chance for someone to win
//    +1 : player +1 won
//    -1 : player -1 won
//    0  : game will end as a draw
// attention: the output of tvtest is also a variable called "winner" that differs, 
//					see "tvtest.m" for details

function [winner,m]=winnertest_preframes(m,mc,dwin),
[dr,dc]=size(mc);             // stores the size of mc
winner=[99,99];               // initializes winner
tv=zeros(1,dwin);					// initializes tv
for r=1:dr,
   for c=1:dc,
      select mc(r,c) // check, if someone won
      case 0 then
         // no action necessary
      case 1 then
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c-i); // SW
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c-i)=0;
            end
            return
			end
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c); // S
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c)=0;
            end
            return
         end
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c+i); // SE
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c+i)=0;
            end            
            return
			end         
         for i=0:dwin-1,
            tv(i+1)=m(r,c+i); // E
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r,c+i)=0;
            end
            return
			end         
      case 2 then
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c); // S
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c)=0;
            end
            return
			end         
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c+i); // SE
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c+i)=0;
            end
            return
			end         
         for i=0:dwin-1,
            tv(i+1)=m(r,c+i); // E
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r,c+i)=0;
            end
            return
			end         
      case 3 then
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c-i); // SW
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c-i)=0;
            end
            return
			end         
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c); // S
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c)=0;
            end
            return
			end         
      case 4 then
         for i=0:dwin-1,
            tv(i+1)=m(r+i,c); // S
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r+i,c)=0;
            end
            return
			end         
      case 5 then
         for i=0:dwin-1,
            tv(i+1)=m(r,c+i); // E
         end
         winner=tvtest(tv,winner,dwin);
         if winner(1)==-1 | winner(2)==-1, // someone won
            for i=0:dwin-1,
               m(r,c+i)=0;
            end
            return
			end         
      end
   end
end
