//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*	Temporal Difference               *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//************************************************//
//*       Policy choice from Q s' and epsilon    *//
//************************************************//


function a=Policy(Q,Actionstates,s,Epsilon)

NbActions = size(Q,2);

//Epsilon greedy
if rand() < Epsilon then // random selection

  // now we choose randomly a valid action
  nbvalidactions=sum(Actionstates(s,:));
  a=MyRandom(1,nbvalidactions);
  j=0;
  i=0;
  while j<a
    i = i+1;
    while Actionstates(s,i) == 0
      i = i+1;
    end
    j = j+1;
  end
  a=i
else // greedy (1-Epsilon) selection

  Max = -%inf;
  for i=1:NbActions

    if Actionstates(s,i) == 1 then
      if Q(s,i)>Max then
	Max=Q(s,i);
	a=i;
      end
    end
  end
end
endfunction

//************************************************//
//*       Random int number between Min and Max  *//
//************************************************//

function r=MyRandom(Min,Max)

r=1;
while r==1
  r=rand();
end
r=r*(Max-Min+1);
r=r+Min;
r=floor(r);

endfunction
