//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*	Temporal Difference               *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//************************************************//
//*       Q-learning: Off-Policy TD Control      *//
//************************************************//


function Q=TD_Q_learning(NbEpisodes,Actionstates,NbStates,NbActions,Alpha,Gamma,Epsilon)
TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
TK_EvalStr('wm title .pliz_wait ""TD Q_Learning""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
TK_EvalStr('pack .pliz_wait.l -fill both');
timer();
Q=zeros(NbStates,NbActions);            // Arbitrary initialisation

for i=1:NbEpisodes                // for each episode
  s=TD_Mdl_first_state();                 //first state s
	TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string(round(10000*(i-1)/NbEpisodes)/100)+'% done""');
  while TD_Mdl_terminal_state(s)==0     //for each step in episode

    a=Policy(Q,Actionstates,s,Epsilon);         //action a from state s
    
    [sprime,r]=TD_Mdl_nextstate_reward(s,a);      //state s' (next step state) and reward

    Q(s,a)=Q(s,a)+Alpha*(r+Gamma*max(Q(sprime,:))-Q(s,a));

    s=sprime;
  end
end
TK_EvalStr('.pliz_wait.l configure -text ""Simulation completed in '+string(timer())+' seconds""');
endfunction

