//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*   Temporal Difference             *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//***********************************************************//
//*       R-learning: for Undiscounted Continual Tasks      *//
//***********************************************************//


function Q=TD_R_learning(NbIterations,Actionstates,NbStates,NbActions,Alpha,Beta,Epsilon)
TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
TK_EvalStr('wm title .pliz_wait ""TD R_Learning""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
TK_EvalStr('pack .pliz_wait.l -fill both');
timer();
Q=zeros(NbStates,NbActions);                     // Arbitrary initialisation 
rho=0;

s=TD_Mdl_first_state();                          //start on 1st state

for i=1:NbIterations                             // for each iteration
  TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string(round(10000*(i-1)/NbEpisodes)/100)+'% done""');
  a=Policy(Q,Actionstates,s,Epsilon);            //action a from state s
   
  [sprime,r]=TD_Mdl_nextstate_reward(s,a);                 //state s' (next step state) and reward

  dummy=r-rho+max(Q(sprime,:))-Q(s,a); //use dummy for optmisation
  
  Q(s,a)=Q(s,a)+Alpha*dummy;                      //update Q

  if Q(s,a) == max((Q(s,:))) then
    rho = rho + Beta*dummy;
  end

  s=sprime;
end
TK_EvalStr('.pliz_wait.l configure -text ""Simulation completed in '+string(timer())+' seconds""');
endfunction

