//*************************************//
//*   Reinforcement Learning Toolbox  *//
//*	Temporal Difference               *//
//*   T. AL ANI                       *//
//*   ESIEE-ASI Paris - March 2004   *//
//*************************************//

//************************************************//
//*        TD prediction (policy Evaluation)     *//
//************************************************//


function [V,T]=TD_nonbatch_prediction(NbEpisodes,NbStates,NbActions,Alpha,Gamma)
TK_EvalStr('if [winfo exists .pliz_wait]==1 {	destroy .pliz_wait	}');
TK_EvalStr('toplevel .pliz_wait');
TK_EvalStr('wm geometry .pliz_wait +[expr int($Main_width/2.5)]+$Main_height');
TK_EvalStr('wm title .pliz_wait ""TD Prediction""');
TK_EvalStr('label .pliz_wait.l -text ""Please Wait a little ...""');
TK_EvalStr('pack .pliz_wait.l -fill both');
timer();

V=zeros(NbStates,1); // Arbitrary initialisation
T=list(); //we memorize some values of V
Step=NbEpisodes/3; //we want 3 step of memorisation
cptr=0;
for i=1:NbEpisodes                // for each episode
  s=TD_Mdl_first_state();                  //first state s
  TK_EvalStr('.pliz_wait.l configure -text ""Please Wait a little ...\n'+string(round(10000*(i-1)/NbEpisodes)/100)+'% done""');
  while TD_Mdl_terminal_state(s)==%f

    a=TD_Mdl_Policy(s);                 //action given by pi for s
    [sprime ,r]=TD_Mdl_nextstate_reward(s,a);      //observe state s' (next step state)
    V(s) = V(s) + Alpha * (r + Gamma*V(sprime) - V(s) );
    s=sprime;

  end
  if modulo(i,Step)
        cptr=cptr+1;
  	T(cptr)=V;
  end
end
TK_EvalStr('.pliz_wait.l configure -text ""Simulation completed in '+string(timer())+' seconds""');
endfunction


